
#include "../../../defs.h"
#include "../../mod_defs.h"
#include "../../mod_functions.h"
#include "../../mod_variables.h"
////////////////////////////////////////////////////////////////////////////

int g_curx, g_cury;
BOOL g_isKlick = FALSE;


//------------------------------------------------------------------------------------------------------------- WM_LBUTTONDOWN
void __stdcall OnLBUTTONDOWN(cKernel* pKer, cEventMouseButtonDown* pEvt, int nEvtCat, int when_in_ms)
{
	int x = pEvt->pt.x;
	int y = pEvt->pt.y;
	g_curx = x; g_cury = y;
	g_isKlick = TRUE;


	Kernel_ReceiveEvent(pKer, (cEvent*)pEvt, nEvtCat, when_in_ms);
}

//------------------------------------------------------------------------------------------------------------- WM_LBUTTONUP
void __stdcall OnLBUTTONUP(cKernel* pKer, cEventMouseButtonUp* pEvt, int nEvtCat, int when_in_ms)
{
	int x = pEvt->pt.x;
	int y = pEvt->pt.y;
	g_isKlick = FALSE;


	Kernel_ReceiveEvent(pKer, (cEvent*)pEvt, nEvtCat, when_in_ms);
}

//------------------------------------------------------------------------------------------------------------- WM_LBUTTONDBLCLK
void __stdcall OnLBUTTONDBLCLK(cKernel* pKer, cEventMouseButtonDown* pEvt, int nEvtCat, int when_in_ms)
{
	int x = pEvt->pt.x;
	int y = pEvt->pt.y;


	Kernel_ReceiveEvent(pKer, (cEvent*)pEvt, nEvtCat, when_in_ms);
}

//------------------------------------------------------------------------------------------------------------- WM_RBUTTONDOWN
void __stdcall OnRBUTTONDOWN(cKernel* pKer, cEventMouseButtonDown* pEvt, int nEvtCat, int when_in_ms)
{
	int x = pEvt->pt.x;
	int y = pEvt->pt.y;


	Kernel_ReceiveEvent(pKer, (cEvent*)pEvt, nEvtCat, when_in_ms);
}

//------------------------------------------------------------------------------------------------------------- WM_RBUTTONUP
void __stdcall OnRBUTTONUP(cKernel* pKer, cEventMouseButtonUp* pEvt, int nEvtCat, int when_in_ms)
{
	int x = pEvt->pt.x;
	int y = pEvt->pt.y;


	Kernel_ReceiveEvent(pKer, (cEvent*)pEvt, nEvtCat, when_in_ms);
}

//------------------------------------------------------------------------------------------------------------- WM_RBUTTONDBLCLK
void __stdcall OnRBUTTONDBLCLK(cKernel* pKer, cEventMouseButtonDown* pEvt, int nEvtCat, int when_in_ms)
{
	int x = pEvt->pt.x;
	int y = pEvt->pt.y;


	Kernel_ReceiveEvent(pKer, (cEvent*)pEvt, nEvtCat, when_in_ms);
}

//------------------------------------------------------------------------------------------------------------- WM_MOUSEMOVE
void __stdcall OnMOUSEMOVE(cKernel* pKer, cEventMouseMove* pEvt, int nEvtCat, int when_in_ms)
{
	int x = pEvt->pt2.x;
	int y = pEvt->pt2.y;
	g_curx = x; g_cury = y;


	Kernel_ReceiveEvent(pKer, (cEvent*)pEvt, nEvtCat, when_in_ms);
}

//------------------------------------------------------------------------------------------------------------- WM_CHAR
void __stdcall OnCHAR(int nScreen, cKernel* pKer, cEventKey* pEvt, int nEvtCat, int when_in_ms)
{
	//-----------------------------------------------------------------------------
	//   
	//-----------------------------------------------------------------------------
	if(nScreen == 1)
	{
	}

	//-----------------------------------------------------------------------------
	//  
	//-----------------------------------------------------------------------------
	if(nScreen == 2)
	{
	}


	//----------------------------------------------
	Kernel_ReceiveEvent(pKer, (cEvent*)pEvt, nEvtCat, when_in_ms);
}


//------------------------------------------------------------------------------------------------------------- WM_KEYUP
void __stdcall OnKEYUP(int nScreen, cKernel* pKer, cEventKey* pEvt, int nEvtCat, int when_in_ms)
{
	if(nScreen == 2)
	{
	}



	//----------------------------------------------
	Kernel_ReceiveEvent(pKer, (cEvent*)pEvt, nEvtCat, when_in_ms);
}

//------------------------------------------------------------------------------------------------------------- WM_KEYDOWN
void __stdcall OnKEYDOWN(cKernel* pKer, cEventKey* pEvt, int nEvtCat, int when_in_ms)
{


	//----------------------------------------------
	Kernel_ReceiveEvent(pKer, (cEvent*)pEvt, nEvtCat, when_in_ms);
}




//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
DWORD dw000513; // WM_LBUTTONDOWN
DWORD dw000514; // WM_LBUTTONUP
DWORD dw000515; // WM_LBUTTONDBLCLK
DWORD dw000516; // WM_RBUTTONDOWN
DWORD dw000517; // WM_RBUTTONUP
DWORD dw000518; // WM_RBUTTONDBLCLK
DWORD dw000512; // WM_MOUSEMOVE
DWORD dw0002581; // WM_CHAR
DWORD dw0002582; // WM_CHAR
DWORD dw000257; // WM_KEYUP
DWORD dw000357; // WM_KEYUP
DWORD dw000256; // WM_KEYDOWN
//----------------------------------------------------------------------
void __NAKED TheWM_LBUTTONDOWN_STUB()
{
	__asm
	{
		pop dw000513
		push ecx
		call OnLBUTTONDOWN
		jmp dw000513
	}
}
//----------------------------------------------------------------------
void __NAKED TheWM_LBUTTONUP_STUB()
{
	__asm
	{
		pop dw000514
		push ecx
		call OnLBUTTONUP
		jmp dw000514
	}
}
//----------------------------------------------------------------------
void __NAKED TheWM_LBUTTONDBLCLK_STUB()
{
	__asm
	{
		pop dw000515
		push ecx
		call OnLBUTTONDBLCLK
		jmp dw000515
	}
}
//----------------------------------------------------------------------
void __NAKED TheWM_RBUTTONDOWN_STUB()
{
	__asm
	{
		pop dw000516
		push ecx
		call OnRBUTTONDOWN
		jmp dw000516
	}
}
//----------------------------------------------------------------------
void __NAKED TheWM_RBUTTONUP_STUB()
{
	__asm
	{
		pop dw000517
		push ecx
		call OnRBUTTONUP
		jmp dw000517
	}
}
//----------------------------------------------------------------------
void __NAKED TheWM_RBUTTONDBLCLK_STUB()
{
	__asm
	{
		pop dw000518
		push ecx
		call OnRBUTTONDBLCLK
		jmp dw000518
	}
}
//----------------------------------------------------------------------
void __NAKED TheWM_MOUSEMOVE_STUB()
{
	__asm
	{
		pop dw000512
		push ecx
		call OnMOUSEMOVE
		jmp dw000512
	}
}
//----------------------------------------------------------------------
void __NAKED TheWM_CHAR_STUB_1()
{
	__asm
	{
		pop dw0002581
		push ecx
		push 1
		call OnCHAR
		jmp dw0002581
	}
}
void __NAKED TheWM_CHAR_STUB_2()
{
	__asm
	{
		pop dw0002582
		push ecx
		push 2
		call OnCHAR
		jmp dw0002582
	}
}
//----------------------------------------------------------------------
void __NAKED TheWM_KEYUP_STUB_1()
{
	__asm
	{
		pop dw000357
		push ecx
		push 1
		call OnKEYUP
		jmp dw000357
	}
}
void __NAKED TheWM_KEYUP_STUB_2()
{
	__asm
	{
		pop dw000257
		push ecx
		push 2
		call OnKEYUP
		jmp dw000257
	}
}
//----------------------------------------------------------------------
void __NAKED TheWM_KEYDOWN_STUB()
{
	__asm
	{
		pop dw000256
		push ecx
		call OnKEYDOWN
		jmp dw000256
	}
}


//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
void Install_Event()
{
	call_ref(R8(Sacred, 00811BE2), (DWORD)TheWM_LBUTTONDOWN_STUB);
	call_ref(R8(Sacred, 00811D09), (DWORD)TheWM_LBUTTONUP_STUB);
	call_ref(R8(Sacred, 00811D81), (DWORD)TheWM_LBUTTONDBLCLK_STUB);
	call_ref(R8(Sacred, 00811F14), (DWORD)TheWM_RBUTTONDOWN_STUB);
	call_ref(R8(Sacred, 00811F8C), (DWORD)TheWM_RBUTTONUP_STUB);
	call_ref(R8(Sacred, 00811FE7), (DWORD)TheWM_RBUTTONDBLCLK_STUB);
	call_ref(R8(Sacred, 00811C91), (DWORD)TheWM_MOUSEMOVE_STUB);
	call_ref(R8(Sacred, 00812904), (DWORD)TheWM_CHAR_STUB_1);
	call_ref(R8(Sacred, 00811930), (DWORD)TheWM_CHAR_STUB_2);
	call_ref(R8(Sacred, 008129B2), (DWORD)TheWM_KEYUP_STUB_1);
	call_ref(R8(Sacred, 00811AD6), (DWORD)TheWM_KEYUP_STUB_2);
	call_ref(R8(Sacred, 00811738), (DWORD)TheWM_KEYDOWN_STUB);
	call_ref(R8(Sacred, 0081178F), (DWORD)TheWM_KEYDOWN_STUB);
	call_ref(R8(Sacred, 008117EB), (DWORD)TheWM_KEYDOWN_STUB);
	call_ref(R8(Sacred, 00811850), (DWORD)TheWM_KEYDOWN_STUB);
}

