
#include "../../../defs.h"
#include "../../mod_defs.h"
#include "../../mod_functions.h"
#include "../../mod_variables.h"
////////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
float gf_1024;
float gf_768;
float gf_one1024;
float gf_512;
float gm_512;
float gf_384;
float gm_384;
float gf_200;
float f_242 = 24.2;
float f_482 = 48.2;
float g_half;

//----------------------------------------------------------------------
//		modeltype, weapontype, shieldtype, armortype, bootstype, helmettype, glovestype, belttype, wingstype;
//		posX, posY, posZ;
//		angle
//		lightPosX, lightPosY, lightPosZ
//		screenX, screenY, screenW, screenH;
void SetModels()
{
	DWORD dwPos = R8(Sacred, 009E2250);
	float kx = (float)SCX / 1024.0;
	float ky = (float)SCY / 768.0;
	for(int i=0; i<8; i++)
	{
		sUiModels* m = &g_defaultModels[i];
		float xx = (float)(atan((double)SCX / 73.530141 / 20.0) * 2.0 / 69.7);
		float yy = (float)(atan((double)SCY / 78.254468 / 20.0) * 2.0 / 69.7);

		m->posX *= kx;
		m->lightPosX *= kx;
		m->screenX *= kx;

		m->lightPosY *= ky;
		m->screenY *= ky;

		m->posZ *= ky;
		m->posZ -= ky * 1.42;
		m->lightPosZ *= ky;
		m->screenW *= kx;
		m->screenH *= ky;

		for(int j=0; j<20; j++)
		{
			DWORD dw = *((DWORD*)m + j);
			dwPos = SetDWORD(dwPos, dw);
		}
	}
}
/*
	float posX;
	float posY;
	float posZ;
	float angle;
	float lightPosX;
	float lightPosY;
	float lightPosZ;
	float screenX;
	float screenY;
	float screenW;
	float screenH;
*/


//-------------------------------------------------------------------
void __stdcall TheRectangleHCX(cRectangle* pInfo, DWORD dwX, DWORD dwY, WORD wCx, WORD wCy)
{
	cRectangle_Init(pInfo, HCX + dwX, dwY, wCx, wCy);
}
NAKED_FUNC(dw76499837, TheRectangleHCX_STUB)
{
	push ecx
	call TheRectangleHCX;
	END_FUNC(dw76499837)
}

//------------------------------------------------------------------- cx=696
cRectangle* __stdcall TheRectangle335(cRectangle* pInfo, DWORD dwX, DWORD dwY, WORD wCx, WORD wCy)
{
	return cRectangle_Init(pInfo, DCX, dwY, wCx, wCy);
}
NAKED_FUNC(dwInv64543, TheRectangle335_STUB)
{
	push ecx
	call TheRectangle335;
	END_FUNC(dwInv64543)
}

//-------------------------------------------------------------------
cRectangle* __stdcall TheRectangleAdd335(cRectangle* pInfo, DWORD dwX, DWORD dwY, WORD wCx, WORD wCy)
{
	return cRectangle_Init(pInfo, DCX + dwX, dwY, wCx, wCy);
}
NAKED_FUNC(dwInv64544, TheRectangleAdd335_STUB)
{
	push ecx
	call TheRectangleAdd335;
	END_FUNC(dwInv64544)
}

//------------------------------------------------------------------- cx=896
void __stdcall TheRectangle230(cRectangle* pInfo, DWORD dwX, DWORD dwY, WORD wCx, WORD wCy)
{
	cRectangle_Init(pInfo, (SCX - 896) / 2, dwY, wCx, wCy);
}
NAKED_FUNC(dw26764543, TheRectangle230_STUB)
{
	push ecx
	call TheRectangle230;
	END_FUNC(dw26764543)
}

//-------------------------------------------------------------------
POINT g_inv[7];
void __stdcall TheInventory_LeftBrdPrepare(cUI_Inventory* pInv)
{
	for(int i=0; i<7; i++)
	{
		int j = __rand_range(1, 9);
		int id = 28;
		if(j > 5) id = 29;
		if(j > 8) id = 30;
		g_inv[i].x = DCX - ((id == 30) ? 26 : 16);
		g_inv[i].y = id;
	}
	cUI_Inventory_Default(pInv);
}
NAKED_FUNC(dwInvDef6464, TheInventory_LeftBrdPrepare_STUB)
{
	push ecx
	call TheInventory_LeftBrdPrepare;
	END_FUNC(dwInvDef6464)
}

//-------------------------------------------------------------------
void __stdcall TheInventory_LeftBrdRender(UI_Window* pWnd, IDirect3DDevice7** device)
{
	cUI_Window_Render(pWnd, device);
	DrawIcon(DCX - 16, 388, 32, 1.0, 1.0, 0xFFFFFFFF);

	int y = 404;
	for(int i=0; i<7; i++)
	{
		DrawIcon(g_inv[i].x, y, g_inv[i].y, 1.0, 1.0, 0xFFFFFFFF);
		y += 32;
	}
	DrawIcon(DCX - 16, 628, 33, 1.0, 1.0, 0xFFFFFFFF);
}
NAKED_FUNC(dwInvDr6464, TheInventory_LeftBrdRender_STUB)
{
	push ecx
	call TheInventory_LeftBrdRender;
	END_FUNC(dwInvDr6464)
}

//-------------------------------------------------------------------
cFontMgr* __stdcall TheMerchant_LeftBrdRender()
{
	DrawIcon(DCX - 6, 42, 54, 1.0, 1.0, 0xFFFFFFFF);
	int y = 60;
	for(int i=0; i<8; i++)
	{
		DrawIcon(DCX - 6, y, 34, 1.0, 1.0, 0xFFFFFFFF);
		y += 32;
	}
	DrawIcon(DCX - 6, 305, 52, 1.0, 1.0, 0xFFFFFFFF);
	return Fonts_Create();
}
NAKED_FUNC(dwMerDr6464, TheMerchant_LeftBrdRender_STUB)
{
	call TheMerchant_LeftBrdRender;
	END_FUNC(dwMerDr6464)
}

//-------------------------------------------------------------------
cMouse* __stdcall TheChest_LeftBrdRender(UI_Window* pWnd)
{
	cUI_Window_Render(pWnd, (*g_dxDriver7)->device);
	DrawIcon(DCX - 6, 9, 54, 1.0, 1.0, 0xFFFFFFFF);
	DrawIcon(DCX + 611, 8, 55, 1.0, 1.0, 0xFFFFFFFF);
	int y = 28;
	for(int i=0; i<9; i++)
	{
		DrawIcon(DCX - 6, y, 34, 1.0, 1.0, 0xFFFFFFFF);
		y += 32;
	}
	DrawIcon(DCX - 6, 305, 52, 1.0, 1.0, 0xFFFFFFFF);
	return cMouse_Instance();
}
NAKED_FUNC(dwCheDr6464, TheChest_LeftBrdRender_STUB)
{
	push edi
	call TheChest_LeftBrdRender;
	END_FUNC(dwCheDr6464)
}

//-------------------------------------------------------------------
cObject* __stdcall TheTrade_LeftBrdRender(cObjectManager* pObj, DWORD id)
{
	DrawIcon(DCX - 6, 9, 54, 1.0, 1.0, 0xFFFFFFFF);
	DrawIcon(DCX + 611, 8, 55, 1.0, 1.0, 0xFFFFFFFF);
	int y = 28;
	for(int i=0; i<9; i++)
	{
		DrawIcon(DCX - 6, y, 34, 1.0, 1.0, 0xFFFFFFFF);
		y += 32;
	}
	DrawIcon(DCX - 6, 305, 52, 1.0, 1.0, 0xFFFFFFFF);
	return cObjectManager_GetData(pObj, id);
}
NAKED_FUNC(dwTreDr6464, TheTrade_LeftBrdRender_STUB)
{
	push ecx
	call TheTrade_LeftBrdRender;
	END_FUNC(dwTreDr6464)
}

//-------------------------------------------------------------------
NAKED_FUNC(dwTrade92, TheTrade92_STUB)
{
	lea eax, [esi+1F4h]
	add ecx, DCX
	END_FUNC(dwTrade92)
}
NAKED_FUNC(dwTrade48A, TheTrade48A_STUB)
{
	lea ecx, [ebx+30h]
	add ecx, DCX
	and eax, 0FFFFh
	END_FUNC(dwTrade48A)
}
NAKED_FUNC(dwTrade92A, TheTrade92A_STUB)
{
	lea edx, [esi+2ECh]
	lea ebx, [ebx+ebp+5Ch]
	add ebx, DCX
	END_FUNC(dwTrade92A)
}
NAKED_FUNC(dwTrade33, TheTrade33_STUB)
{
	lea ecx, [esi+368h]
	lea eax, [ebp-21h]
	add eax, DCX
	END_FUNC(dwTrade33)
}
NAKED_FUNC(dwTrade16, TheTrade16_STUB)
{
	lea edx, [esi+3E4h]
	add ebp, 0FFFFFFF0h
	add ebp, DCX
	END_FUNC(dwTrade16)
}

//-------------------------------------------------------------------
void __stdcall TheMaster_LeftBrdRender(UI_Window* pWnd, IDirect3DDevice7** device)
{
	cUI_Window_Render(pWnd, device);
	DrawIcon(DCX - 6, 42, 54, 1.0, 1.0, 0xFFFFFFFF);
	int y = 60;
	for(int i=0; i<8; i++)
	{
		DrawIcon(DCX - 6, y, 34, 1.0, 1.0, 0xFFFFFFFF);
		y += 32;
	}
	DrawIcon(DCX - 6, 305, 52, 1.0, 1.0, 0xFFFFFFFF);
}
NAKED_FUNC(dwMasDr346, TheMaster_LeftBrdRender_STUB)
{
	push ecx
	call TheMaster_LeftBrdRender;
	END_FUNC(dwMasDr346)
}

//-------------------------------------------------------------------
NAKED_FUNC(dw0888474, TABPAGE_ITEMS_STUB)
{
	mov eax, DCX
	mov word ptr [esi+1164h], ax
	END_FUNC(dw0888474)
}
NAKED_FUNC(dw91289374, TABPAGE_WEAPONS_STUB)
{
	mov eax, DCX
	mov [esi+24h], eax
	mov [esi+28h], 0
	END_FUNC(dw91289374)
}

//---------------------------------------------------------------------------------- cUI_MainMenu
void __stdcall UI_MAINMENU_InfoUI(cRectangle* pInfo, int dwX, int dwY, WORD wCx, WORD wCy)
{
	cRectangle_Init(pInfo, -HCX, dwY, SCX, wCy);
}
NAKED_FUNC(dw2323442, UI_MAINMENU_InfoUI_STUB)
{
	push ecx
	call UI_MAINMENU_InfoUI;
	END_FUNC(dw2323442)
}

//-------------------------------------------------------------------
void __stdcall MainMenu_BackToScreen(cRectangle *pInfo, int nX, int nY, WORD wCx, WORD wCy)
{
	nX = (nX * SCX / 1024) - HCX;
	nY = (nY * SCY / 768);// - HCY;
	cRectangle_Init(pInfo, nX, nY, (int)ceil((float)SCX / 4.0), (int)ceil((float)SCY / 3.0));
}
NAKED_FUNC(dw0112983, MainMenu_BackToScreen_STUB)
{
	push ecx
	call MainMenu_BackToScreen;
	END_FUNC(dw0112983)
}

//-------------------------------------------------------------------
void __stdcall BackToScreen(cRectangle *pInfo, int nX, int nY, WORD wCx, WORD wCy)
{
	nX = (nX * SCX / 1024);
	nY = (nY * SCY / 768);
	cRectangle_Init(pInfo, nX, nY, (int)ceil((float)SCX / 4.0), (int)ceil((float)SCY / 3.0));
}
NAKED_FUNC(dw9477728, BackToScreen_STUB)
{
	push ecx
	call BackToScreen;
	END_FUNC(dw9477728)
}

//-------------------------------------------------------------------
NAKED_FUNC(dw222746, TheSpells1_STUB)
{
	mov eax, DCX
	add eax, 40
	push edx
	push eax
	push 43h
	END_FUNC(dw222746)
}
NAKED_FUNC(dw222747, TheSpells2_STUB)
{
	mov edx, DCX
	add edx, 112
	push eax
	push edx
	push 3Ch
	END_FUNC(dw222747)
}

//-------------------------------------------------------------------
void __stdcall TheInitFrameBusy(UI_Window* pWnd, int frame, cRectangle* pRect, int stp)
{
	pRect->x += HCX;
	pRect->y += HCY;
	cUI_BusyDlg* b = (cUI_BusyDlg*)pWnd;
	b->busyRect.x = pRect->x;
	b->busyRect.y = pRect->y;
	cUI_Window_InitFrame(pWnd, frame, pRect, stp);
	if(stp == 4)
	{
		b->busyRect.x += 20;
		b->busyRect.y -= 10;
	}
}
NAKED_FUNC(dw8873766, TheInitFrameBusy_STUB)
{
	push ecx
	call TheInitFrameBusy;
	END_FUNC(dw8873766)
}

//-------------------------------------------------------------------
void __stdcall TheRectBusy(cRectangle* dest, cRectangle* src)
{
	cRectangle_Copy(dest, src);
	dest->x += HCX;
	dest->y += HCY;
}
NAKED_FUNC(dw8877356, TheRectBusy_STUB)
{
	push ecx
	call TheRectBusy;
	END_FUNC(dw8877356)
}

//------------------------------------------------------------------- TheLoadingScreen
BOOL g_isStretchBlt = FALSE;
int oldProgress = -1;
char theText[256];
void __stdcall TheLoadingScreen(float proc, LPCSTR lpchText)
{
	dxDriver7* pDir = *g_dxDriver7;
	int v5;
	HDC hBmp;
	HDC bmp;
	DWORD rop;
	HDC hSurf = NULL;
	int v10;
	HDC v12;
	HGDIOBJ old;
	float delta = -7.6700001;

	if(pDir && pDir->back)
	{
		if(proc > 0.000099999997)
		{
			if(proc > 100.0) proc = 100.0;
		}
		else
		{
			proc = 0.0;
		}
		v5 = 23 - (int)(proc * delta);
		if(v5 != oldProgress)
		{
			oldProgress = 23 - (int)(proc * delta);
			if(lpchText)
			{
				strcpy(theText, lpchText);
			}
			else
			{
				theText[0] = 0;
			}

			IDirectDrawSurface7** sur = pDir->back;
			HRESULT hres = (*sur)->GetDC(sur, &hSurf);

			if(!hres && hSurf)
			{
				hBmp = ::CreateCompatibleDC(hSurf);
				if(pDir->curLoadBmp)
				{
					old = ::SelectObject(hBmp, pDir->curLoadBmp);
					rop = 0x00CC0020;
					bmp = hBmp;
				}
				else
				{
					rop = 66;
					bmp = 0;
				}
				if(g_isStretchBlt)
				{
					::SetStretchBltMode(hSurf, COLORONCOLOR);
					::StretchBlt(hSurf, 0, 0, SCX, SCY, bmp, 0, 0, 1024, 768, rop);
				}
				else
				{
					_EcxFastColorRect(hSurf, 0, 0, SCX, SCY, 0x00000000);
					::BitBlt(hSurf, HCX, HCY, 1024, 768, bmp, 0, 0, rop);
				}
				if(pDir->progBarFull)
				{
					old = ::SelectObject(hBmp, pDir->progBarFull);
					rop = 0x00CC0020;
					v12 = hBmp;
				}
				else
				{
					rop = 0;
					v12 = 0;
				}
				v10 = 23 - (int)(proc * delta);
				::BitBlt(hSurf, (SCX - 813) / 2, SCY - 68, v10, 35, v12, 0, 0, rop);
				if(pDir->progBarEmpty)
				{
					old = ::SelectObject(hBmp, pDir->progBarEmpty);
					::BitBlt(hSurf, v10 + (SCX - 813) / 2, SCY - 68, 813 - v10, 35, hBmp, v5, 0, 0x00CC0020);
				}
				if(lpchText)
				{
					RECT rc;
					::SetBkMode(hSurf, TRANSPARENT);
					HGDIOBJ hFontOld = NULL;
					if(pDir->progBarFont)
						hFontOld = ::SelectObject(hSurf, pDir->progBarFont);
					::SetTextColor(hSurf, 0);
					::SetRect(&rc, 0, SCY - 68, SCX, SCY - 33);
					::OffsetRect(&rc, 2, 2);
					char text[256];
					sprintf(text, "%s", lpchText);
					DWORD len = strlen(text);
					::DrawTextA(hSurf, text, strlen(text), &rc, DT_SINGLELINE|DT_VCENTER|DT_CENTER);
					::SetTextColor(hSurf, 0x00A5E8F8);
					::OffsetRect(&rc, -2, -2);
					::DrawTextA(hSurf, text, strlen(text), &rc, DT_SINGLELINE|DT_VCENTER|DT_CENTER);
					if(hFontOld)
						::SelectObject(hSurf, hFontOld);
				}
				::SelectObject(hBmp, old);

				old = ::SelectObject(hBmp, g_hBmpPHD);
				::BitBlt(hSurf, 30, 20, 256, 64, hBmp, 0, 0, 0x00CC0020);
				::SelectObject(hBmp, old);

				::DeleteDC(hBmp);
				(*sur)->ReleaseDC(sur, hSurf);

			}
			dxDriver7_Flip(pDir);
		}
	}
}
NAKED_STUB(eax, dw8839948, TheLoadingScreen_STUB)
{
	call TheLoadingScreen
	END_FUNC(dw8839948)
}

//---------------------------------------------------------------------- TheSetCurLoadBmp
bool __stdcall TheSetCurLoadBmp(dxDriver7* pDir, char* bmpFilename)
{
	g_isStretchBlt = !(_stricmp(bmpFilename, "PAK\\LoadingUW00.bmp") != 0);
	return dxDriver7_SetCurLoadBmp(pDir, bmpFilename);
}
NAKED_FUNC(dw777253, TheSetCurLoadBmp_STUB)
{
	push ecx
	call TheSetCurLoadBmp;
	END_FUNC(dw777253)
}

//----------------------------------------------------------------------
DWORD g_hx = 512;
DWORD g_hy = 384;
DWORD g_hhx = 0;
float ov768;
float ov512 = 512.0;
float ov384 = 384.0;

void OverviewInit(int hx, int hy)
{
	g_hx = hx;
	g_hy = hy;
	g_hhx = g_hx - 512;
	ov512 = (float)hx;
	ov384 = (float)hy;
}
NAKED_FUNC(dw00993883, TheQuestOffset0)
{
	sub eax, 8
	mov [esp+54h], eax
	add edi, HCX
	sub edi, 8
	END_FUNC(dw00993883)
}
NAKED_FUNC(dw00993884, TheQuestOffset)
{
	sub eax, 8
	mov [esp+54h], eax
	add edi, g_hhx
	sub edi, 8
	END_FUNC(dw00993884)
}
NAKED_FUNC(dw00512, mov_eax_512)
{
	mov eax, g_hx
	END_FUNC(dw00512)
}
NAKED_FUNC(dw00513, add_ecx_512)
{
	add ecx, g_hx
	END_FUNC(dw00513)
}
NAKED_FUNC(dw00514, mov_ecx_512)
{
	mov ecx, g_hx
	END_FUNC(dw00514)
}
NAKED_FUNC(dw00515, add_edx_512)
{
	add edx, g_hx
	END_FUNC(dw00515)
}
NAKED_FUNC(dw00516, mov_edx_384)
{
	mov edx, g_hy
	END_FUNC(dw00516)
}
NAKED_FUNC(dw00517, add_eax_384)
{
	add eax, g_hy
	END_FUNC(dw00517)
}
NAKED_FUNC(dw00518, lea_ecx_384)
{
	push eax
	mov eax, g_hy
	lea ecx, [ebp+eax]
	pop eax
	END_FUNC(dw00518)
}
NAKED_FUNC(dw00519, mov_eax_384)
{
	mov eax, g_hy
	END_FUNC(dw00519)
}

NAKED_FUNC(dw01512, fld_ds_512)
{
	fld ds:ov512
	END_FUNC(dw01512)
}
NAKED_FUNC(dw01513, fadd_ds_512)
{
	fadd ds:ov512
	END_FUNC(dw01513)
}

NAKED_FUNC(dw01514, fld_ds_384)
{
	fld ds:ov384
	END_FUNC(dw01514)
}
NAKED_FUNC(dw01515, fadd_ds_384)
{
	fadd ds:ov384
	END_FUNC(dw01515)
}

//----------------------------------------------------------------------
NAKED_FUNC(dw999384, water_cache_STUB)
{
	mov eax, [ebp+80E3Ch]
	cmp eax, 8160
	jl M1
	mov eax, 8160
	mov [ebp+80E3Ch], eax
M1:
	END_FUNC(dw999384)
}

//-------------------------------------------------------------------
NAKED_FUNC(dw840039, TheRectangleOverviewMap_STUB)
{

	mov eax, HCY
	add eax, 122
	push eax
	mov eax, HCX
	add eax, 162
	push eax
	END_FUNC(dw840039)
}

//----------------------------------------------------------
cDxDisplayMode* __stdcall TheDxDeviceGetMode(cDxDevice* pDev, __int16 scx, __int16 scy, eDisplayDepth depth, eDisplayType t)
{
	pDev->DeviceMode[0].ddsd.dwWidth = scx;
	pDev->DeviceMode[0].ddsd.dwHeight = scy;
	pDev->DeviceMode[0].depth = depth;
	pDev->DeviceMode[0].type = t;
	return &pDev->DeviceMode[0];
}
NAKED_FUNC(dw8837639, TheDxDeviceGetMode_STUB)
{
	push ecx
	call TheDxDeviceGetMode
	END_FUNC(dw8837639)
}

//----------------------------------------------------------
// Mini-Screenshot
//----------------------------------------------------------
NAKED_FUNC(dw9938874, TheCaptureScreenSize_STUB)
{
	push eax
	mov eax, SCX
	mov edx, SCY
	imul edx
	mov ecx, eax
	pop eax
	imul ecx
	mov edx, eax
	END_FUNC(dw9938874)
}
NAKED_FUNC(dw9938875, TheCaptureScreenLineSize_STUB)
{
	push edx
	and esi, 0FFFFh
	mov eax, SCX
	mov ecx, esi
	imul ecx
	mov ecx, eax
	xor eax, eax
	pop edx
	END_FUNC(dw9938875)
}

//----------------------------------------------------------
// Screenshot
//----------------------------------------------------------
DDSURFACEDESC2 g_Surface;//sizeof=0x7C
NAKED_FUNC(dw8837746, TheScreenshot_BackSurface_STUB)
{
	lea ecx, [esp+10h]		//DDSURFACEDESC2*
	push esi
	push edi
	mov esi, ecx
	lea edi, g_Surface
	mov ecx, 1Fh
	rep movsd
	pop edi
	pop esi
	mov ecx, [esp+34h]
	test ecx, ecx
	END_FUNC(dw8837746)
}
NAKED_FUNC(dw8837747, TheScreenshot_Pitch_STUB)
{
	push eax
	lea eax, g_Surface
	mov edi, [eax+10h]		//DDSURFACEDESC2.lPitch
	pop eax
	END_FUNC(dw8837747)
}
NAKED_FUNC(dw8837748, TheScreenshot_Depth_STUB)
{
	mov eax, ds: 00CDB99Ch	//g_dxDriver7
	mov eax, [eax+94h]		//(*g_dxDriver7)->mode.depth
	cmp eax, 32
	END_FUNC(dw8837748)
}
NAKED_FUNC(dw8837749, TheScreenshot001_STUB)
{
	push eax
	lea eax, g_Surface
	mov esi, [eax+10h]
	mov eax, esi	
	mov ecx, SCY
	dec ecx
	imul ecx
	mov ebx, eax
	pop eax
	neg edi
	END_FUNC(dw8837749)
}
NAKED_FUNC(dw8837745, TheScreenshot002_STUB)
{
	mov edx, SCX
	shl edx, 1
	push edx
	add eax, 4
	END_FUNC(dw8837745)
}
NAKED_FUNC(dw8834746, TheScreenshot003_STUB)
{
	mov edx, SCX
	shl edx, 1
	push edx
	add ebx, 4
	END_FUNC(dw8834746)
}

//-------------------------------------------------------------------
NAKED_FUNC(dw234567, TheNetPortraitY_STUB)
{
	push edi
	mov ebp, 34
	mov [esp+14h], ebp
	xor ebp, ebp
	END_FUNC(dw234567)
}

//-------------------------------------------------------------------
void __stdcall TheRenderFrom(int nTextWidth, int nTextHeight)
{
	int x = SCX2 - nTextWidth / 2;
	int y = SCY - 152;
	int n1 = (nTextWidth + 4) / 38;
	int n2 = nTextWidth + 4 - n1 * 38;

	x -= 2;
	DrawIcon(x - 45, y - 4, 280, 1.0, 1.0, 0xFFFFFFFF);
	for(int i=0; i<n1; i++)
	{
		DrawIcon(x, y - 4, 281, 1.0, 1.0, 0xFFFFFFFF);
		x += 38;
	}
	if(n2)
	{
		DrawIcon(x - 38 + n2, y - 4, 281, 1.0, 1.0, 0xFFFFFFFF);
		x += n2;
	}
	DrawIcon(x, y - 4, 282, 1.0, 1.0, 0xFFFFFFFF);

}
NAKED_FUNC(dw0494984, TheRenderFrom_STUB)
{
	push ebp
	push edx
	push edi
	push eax
	push eax
	push edi
	call TheRenderFrom
	pop eax
	pop edi
	pop edx
	pop ebp
	mov ecx, SCX2
	END_FUNC(dw0494984)
}
DWORD g_dwRenderFromColor = 0xFFFFFFFF;
NAKED_FUNC(dw0494985, TheRenderFromColor_STUB)
{
	push 0
	push g_dwRenderFromColor
	sub esp, 0Ch
	END_FUNC(dw0494985)
}

//-------------------------------------------------------------------
BOOL Trade_IsShow()
{
	if(*g_isNetworkGame)
	{
		cUI_Manager* uim = *g_UI_Manager;
		if(uim)
		{
			if(uim->taskbar.ui_wnd_trade)
				return uim->taskbar.ui_wnd_trade->wnd.base.flags & 1;
		}
	}
	return FALSE;
}

//-------------------------------------------------------------------
int chatX = 10, chatY = 10;
void __stdcall TheChatText(DWORD flag)
{
	chatX = 10;
	chatY = 10;
	if(Trade_IsShow())
	{
		chatX = DCX + 10;
		chatY = 302;
	}
}
NAKED_FUNC(dw0494986, TheChatText1_STUB)
{
	mov edx, [ebx+178h]
	push edx
	call TheChatText
	mov edx, chatX
	mov [esp+34h], edx
	mov edx, chatY
	mov [esp+38h], edx
	xor edx, edx
	END_FUNC(dw0494986)
}
NAKED_FUNC(dw0494987, TheChatText2_STUB)
{
	mov edx, [ebx+178h]
	push edx
	call TheChatText
	add ecx, chatX
	mov [esp+34h], ecx
	add eax, chatY
	mov [esp+38h], eax
	xor edx, edx
	END_FUNC(dw0494987)
}

//-------------------------------------------------------------------
void __stdcall TheCoords(cWorldView2* wview)
{
	int j;
	float x, y;
	for(int i=0; i<18; i++)
	{
		sUV* uv = (sUV*)&wview->uvCoords[i];
		if(i == 0 || i == 4 || i == 8 || i == 12 || i == 16)
		{
			j = i / 4;
			x = 2.0;
			y = 0.0 + 50.0 * j;
		}
		if(i == 1 || i == 5 || i == 9 || i == 13 || i == 17)
		{
			j = (i - 1) / 4;
			x = 2.0 + 104.0;
			y = 0.0 + 50.0 * j;
		}
		if(i == 2 || i == 6 || i == 10 || i == 14)
		{
			j = (i / 2 - 1) / 2;
			x = 54.0;
			y = 25.0 + 50.0 * j;
		}
		if(i == 3 || i == 7 || i == 11 || i == 15)
		{
			j = ((i - 1) / 2 - 1) / 2;
			x = 54.0 + 104.0;
			y = 25.0 + 50.0 * j;
		}
		uv[0].u = (x +  0.0) / 256.0 + 0.001953125;
		uv[0].v = (y + 24.0) / 256.0 + 0.001953125;
		uv[1].u = (x + 48.0) / 256.0 + 0.001953125;
		uv[1].v = (y +  0.0) / 256.0 + 0.001953125;
		uv[2].u = (x + 48.0) / 256.0 + 0.001953125;
		uv[2].v = (y + 48.0) / 256.0 + 0.001953125;
		uv[3].u = (x + 96.0) / 256.0 + 0.001953125;
		uv[3].v = (y + 24.0) / 256.0 + 0.001953125;
	}
}
NAKED_FUNC(dw200993, TheCoords_STUB)
{
	push esi
	call TheCoords
	END_FUNC(dw200993)
}


//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
void Install_HD1366()
{
	//----------------------------------------------------------
	// constants
	//----------------------------------------------------------
	gf_1024 = (float)SCX;
	gf_768 = (float)SCY;
	gf_one1024 = 1.0 / (float)SCX;
	gf_512 = (float)SCX2;
	gm_512 = -(float)SCX2;
	gf_384 = (float)SCY2;
	gm_384 = -(float)SCY2;
	g_half = 0.002;

	//----------------------------------------------------------
	// fast FPS
	//----------------------------------------------------------
	SetBytes(R8(Sacred, 00646313), "EB 24");//while WaitForVerticalBlank
	SetBytes(R8(Sacred, 0060ACE0), __RET(0));//cTimerFrame::LimitFrameRate

	//----------------------------------------------------------
	// HD
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 008158D7), (DWORD)SCX);//1024 fnInitApp: DevMode.dmPelsWidth
	SetDWORD(R8(Sacred, 008158E5), (DWORD)SCY);//768 fnInitApp: DevMode.dmPelsHeight
	SetDWORD(R8(Sacred, 00815E1E), (DWORD)SCX);//1024 fnInitApp: cDxDevice::GetMode
	SetDWORD(R8(Sacred, 00815E19), (DWORD)SCY);//768 fnInitApp: cDxDevice::GetMode
	call_ref(R8(Sacred, 00815E22), (DWORD)TheDxDeviceGetMode_STUB);//--

	//----------------------------------------------------------
	// rdata
	//----------------------------------------------------------
	float d267 = 267.0 * (float)SCX / 1024.0;
	SetDOUBLE(R8(Sacred, 0088FE48), d267);	//! d_267
	SetDOUBLE(R8(Sacred, 0088FE40), -d267);	//! dm_267
	float d200 = 200.0 * (float)SCY / 768.0;
	SetDOUBLE(R8(Sacred, 0088FE58), d200);	//! d_200
	SetDOUBLE(R8(Sacred, 0088FE50), -d200);	//! dm_200
	SetDWORD(R8(Sacred, 00406A4C), (DWORD)&gf_1024);//cGranny::RenderComplex
	SetDWORD(R8(Sacred, 004EC608), (DWORD)&gf_1024);//cCreature::JumpToHero
	SetDWORD(R8(Sacred, 00623F44), (DWORD)&gf_1024);//cWorldPosition::Transform3DTo2D_Car
	SetDWORD(R8(Sacred, 00624E14), (DWORD)&gf_1024);//cWorldView::Init
	SetDWORD(R8(Sacred, 00629287), (DWORD)&gf_1024);//cDrawTLVertex::AddStripQuad2
	SetDWORD(R8(Sacred, 006295B6), (DWORD)&gf_1024);//cDrawTL2Vertex::AddStripQuad
	SetDWORD(R8(Sacred, 0062B74C), (DWORD)&gf_1024);//cWorldView2::DrawLine
	SetDWORD(R8(Sacred, 00630968), (DWORD)&gf_1024);//cWorldView2::RenderObjects
	SetDWORD(R8(Sacred, 00631251), (DWORD)&gf_1024);//--
	SetDWORD(R8(Sacred, 0062ED3D), (DWORD)&gf_1024);//cWorldView2::Renderer
	SetDWORD(R8(Sacred, 0062F61F), (DWORD)&gf_1024);//--
	SetDWORD(R8(Sacred, 0075FBAC), (DWORD)&gf_1024);//cConsoleFX::DrawCircle
	
//	SetDWORD(R8(Sacred, 00406806), (DWORD)&gf_one1024);//cGranny::RenderComplex
//	SetDWORD(R8(Sacred, 004068D9), (DWORD)&gf_one1024);//--
//	SetDWORD(R8(Sacred, 0040A3C5), (DWORD)&gf_one1024);//cGranny::RenderBlink4
//	SetDWORD(R8(Sacred, 0040F5AD), (DWORD)&gf_one1024);//cGranny::RenderMouse3DComplex
//	SetDWORD(R8(Sacred, 0059606A), (DWORD)&gf_one1024);//cCreature::PreRender
//	SetDWORD(R8(Sacred, 0059607E), (DWORD)&gf_one1024);//--
//	SetDWORD(R8(Sacred, 00596F1C), (DWORD)&gf_one1024);//--
//	SetDWORD(R8(Sacred, 00596F2B), (DWORD)&gf_one1024);//--
	SetDWORD(R8(Sacred, 00623D0B), (DWORD)&gf_one1024);//cWorldPosition::Transform2DTo3D_Car
	
	SetFLOAT(R8(Sacred, 0088F6FC), gf_512); // f_512
	SetFLOAT(R8(Sacred, 00891040), (float)SCY); // f_768
	SetFLOAT(R8(Sacred, 0088F9F0), (float)SCY2); // f_384
	SetFLOAT(R8(Sacred, 0089111C), (float)SCY + 50.0); // f_818
	SetFLOAT(R8(Sacred, 0089105C), 1.0 / (float)SCY); // f_one_768
	gf_200 = 200.0 * (float)SCY / 768.0;
	SetDWORD(R8(Sacred, 00628CAc), (DWORD)&gf_200);//--

	SetFLOAT(R8(Sacred, 008910C4), f_242);
	SetFLOAT(R8(Sacred, 008910C8), -f_242);
	SetFLOAT(R8(Sacred, 008910CC), f_482);
	SetFLOAT(R8(Sacred, 008910D0), -f_482);


	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//----------------------------------------------------------
	// water cache
	//----------------------------------------------------------
	call_ref(R8(Sacred, 0062B9D5), (DWORD)water_cache_STUB, 1);//cWorldView2::DrawLine
	SetBytes(R8(Sacred, 006103FA), "68 F4 F0 2E 00");//cEngine::ViewCreate == 618740+8192*152+8192*4*36+8192*4=3076340
	SetBytes(R8(Sacred, 0062B9E9), "89 84 D5 F4 70 09 00");//3FF2C cWorldView2::DrawLine
	SetBytes(R8(Sacred, 0062B9FC), "D9 9C D5 F8 70 09 00");//3FF30
	SetBytes(R8(Sacred, 0062BA19), "D9 9C D5 FC 70 09 00");//3FF34
	SetBytes(R8(Sacred, 0062BA40), "89 9C CD 00 71 09 00");//3FF38
	SetBytes(R8(Sacred, 0062BA5B), "89 84 CD 04 71 09 00");//3FF3C
	SetBytes(R8(Sacred, 0062BA73), "66 89 94 CD 08 71 09 00");//3FF40
	SetBytes(R8(Sacred, 0062BA87), "8D BC CD 0C 71 09 00");//3FF44
	SetBytes(R8(Sacred, 0062BAA7), "8D BC CD 2C 71 09 00");//3FF64
	SetBytes(R8(Sacred, 0062BAC7), "8D BC CD 4C 71 09 00");//3FF84
	SetBytes(R8(Sacred, 0062BAE7), "8D BC CD 6C 71 09 00");//3FFA4
	SetBytes(R8(Sacred, 0062E257), "8D B7 0C 71 09 00");//3FF44 cWorldView2::RenderWater
	SetBytes(R8(Sacred, 0062E562), "8D AF 04 71 09 00");//3FF3C

	//----------------------------------------------------------
	// overlay cache
	//----------------------------------------------------------
	SetBytes(R8(Sacred, 0062B8F2), "8D BC 29 F4 70 1C 00");//0B64
	SetBytes(R8(Sacred, 0062D89E), "8D B7 0C 71 1C 00");//0B7C
	SetBytes(R8(Sacred, 0062B906), "89 84 95 F4 70 2E 00");//3E3C4
	SetBytes(R8(Sacred, 0062D898), "8D 87 F4 70 2E 00");//3E3C4
	SetBytes(R8(Sacred, 0062B913), "3D FF 1F 00 00");//1749

  
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//----------------------------------------------------------
	// rendering
	//----------------------------------------------------------
	SetFLOAT(R8(Sacred, 0040ECD4), gf_512);//442AC000 512.0 cGranny::RenderMouse3D
	SetFLOAT(R8(Sacred, 0040ECD9), gm_512);//C42AC000 -512.0 
	SetFLOAT(R8(Sacred, 0040ECCA), gf_384);//442AC000 384.0
	SetFLOAT(R8(Sacred, 0040ECCF), gm_384);//C42AC000 -384.0 
	SetDWORD(R8(Sacred, 0040ED02), SCX2);//--
	SetDWORD(R8(Sacred, 0040ED59), -SCY2);//--

	SetFLOAT(R8(Sacred, 0040F6DA), gf_512);//442AC000 512.0 cGranny::RenderMouse3DComplex
	SetFLOAT(R8(Sacred, 0040F6DF), gm_512);//C42AC000 -512.0 
	SetFLOAT(R8(Sacred, 0040F6D0), gf_384);//442AC000 384.0
	SetFLOAT(R8(Sacred, 0040F6D5), gm_384);//C42AC000 -384.0 
	SetDWORD(R8(Sacred, 0040F70F), SCX2);
	SetDWORD(R8(Sacred, 0040F765), -SCY2);//--
	
	SetFLOAT(R8(Sacred, 0041000A), gf_512);//442AC000 512.0 cGranny::RenderMouse3DVampire
	SetFLOAT(R8(Sacred, 0041000F), gm_512);//C42AC000 -512.0 
	SetFLOAT(R8(Sacred, 00410000), gf_384);//442AC000 384.0
	SetFLOAT(R8(Sacred, 00410005), gm_384);//C42AC000 -384.0 
	SetDWORD(R8(Sacred, 0041003F), SCX2);//--
	SetDWORD(R8(Sacred, 0041007F), -SCY2);//--
	
	float f267 = 267.0 * (float)SCX / 1024.0;
	SetFLOAT(R8(Sacred, 0060C452), f267);// 267.0 fncEngine_Init
	SetFLOAT(R8(Sacred, 0060C457), -f267);// -267.0 
	SetFLOAT(R8(Sacred, 00625364), f267);// 267.0 fncD3DMATRIX_SetProjection_0
	SetFLOAT(R8(Sacred, 00625369), -f267);// -267.0 
	SetFLOAT(R8(Sacred, 006286DE), f267);// 267.0 cWorldView2::SetViewFactor
	SetFLOAT(R8(Sacred, 006286E3), -f267);// -267.0 
	SetFLOAT(R8(Sacred, 006288B8), f267);// 267.0 fncWorldView2_SetScaleFacrotAndProjection
	SetFLOAT(R8(Sacred, 006288BD), -f267);// -267.0 
	SetFLOAT(R8(Sacred, 00629066), f267);// 267.0 cWorldView::Save2
	SetFLOAT(R8(Sacred, 0062906B), -f267);// -267.0 
	
	float f200 = 200.0 * (float)SCY / 768.0;
	SetFLOAT(R8(Sacred, 0060C448), f200);// 200.0 fncEngine_Init
	SetFLOAT(R8(Sacred, 0060C44D), -f200);// -200.0 
	SetFLOAT(R8(Sacred, 0062535A), f200);// 200.0 fncD3DMATRIX_SetProjection_0
	SetFLOAT(R8(Sacred, 0062535F), -f200);// -200.0 
	SetFLOAT(R8(Sacred, 006286D4), f200);// 200.0 cWorldView2::SetViewFactor
	SetFLOAT(R8(Sacred, 006286D9), -f200);// -200.0 
	SetFLOAT(R8(Sacred, 006288AE), f200);// 200.0 fncWorldView2_SetScaleFacrotAndProjection
	SetFLOAT(R8(Sacred, 006288B3), -f200);// -200.0 
	SetFLOAT(R8(Sacred, 0062905C), f200);// 200.0 cWorldView::Save2
	SetFLOAT(R8(Sacred, 00629061), -f200);// -200.0 
	
	SetDWORD(R8(Sacred, 005D80CD), SCX);// dxDriver7::CreateSurface <- fncInventoryEntry_Init2
	SetDWORD(R8(Sacred, 005D80C8), SCY);// --
	SetDWORD(R8(Sacred, 0061075F), SCX / 4);// cEngine::View_UpdateView
	SetDWORD(R8(Sacred, 0061076D), SCX / 4);//--
	SetDWORD(R8(Sacred, 0041EC19), SCX2);// cAnimation2D::Render
	SetDWORD(R8(Sacred, 0041EC09), SCY2);// --

	SetDWORD(R8(Sacred, 0062BDCD), (DWORD)(-SCX2));//-512 cWorldView2::DrawLine
	SetDWORD(R8(Sacred, 0062BDD2), (DWORD)(-SCY2));//-384 --
	SetDWORD(R8(Sacred, 0062CF52), SCX2);// --
	SetDWORD(R8(Sacred, 0062B7D8), SCX2);// cWorldView2::DrawLine -> cRenderer::Light
	SetDWORD(R8(Sacred, 0062E6AA), SCX2);// cWorldView2::RenderWater
	SetDWORD(R8(Sacred, 0062CF62), SCY2);// cWorldView2::DrawLine
	SetDWORD(R8(Sacred, 0062B7FA), SCY2);// cWorldView2::DrawLine -> cRenderer::Light
	SetDWORD(R8(Sacred, 0062E6BA), SCY2);// cWorldView2::RenderWater

  
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//----------------------------------------------------------
	// viewing
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 00636533), 8192);// cWorld::GetTransitionData
	SetDWORD(R8(Sacred, 00636347), 16384);// cWorld::GetStaticData

	SetDWORD(R8(Sacred, 0062761E), (DWORD)SCX);//1024 cWorldView2::RenderItemText
	SetDWORD(R8(Sacred, 00627619), (DWORD)SCY);//768 --

	SetDWORD(R8(Sacred, 004FBCC2), (DWORD)(-SCX2));//-512 cCreature::FindeFreiWeg
	SetDWORD(R8(Sacred, 004FBCCC), (DWORD)(-SCY2));//-384 --
	SetDWORD(R8(Sacred, 006318BC), (DWORD)SCX2);//512 cWorldView2::RenderObjects
	SetDWORD(R8(Sacred, 006318C1), (DWORD)SCY2);//384 --
	SetDWORD(R8(Sacred, 006318DD), SCX + 200);//1024+200 cWorldView2::RenderObjects 
	SetDWORD(R8(Sacred, 006318FB), SCY + 200);//768+200 -- 

	SetDWORD(R8(Sacred, 00631DDB), (DWORD)SCX2);// cWorldView2::RenderObjects
	SetDWORD(R8(Sacred, 00631DF8), (DWORD)SCY2);// --
	SetDWORD(R8(Sacred, 00631F64), (DWORD)SCX2);// --
	SetDWORD(R8(Sacred, 00631F81), (DWORD)SCY2);// --

	SetDWORD(R8(Sacred, 0041E671), (DWORD)SCX2);// cDialogDamageEntry::Render
	SetDWORD(R8(Sacred, 0041E6A7), (DWORD)SCY2);// --

	SetDWORD(R8(Sacred, 0062FC79), (DWORD)SCX2);// cWorldView2::RenderMinObj
	SetDWORD(R8(Sacred, 0062FC7E), (DWORD)SCY2);// --
	SetDWORD(R8(Sacred, 00630171), (DWORD)SCX2);// --
	SetDWORD(R8(Sacred, 0063018E), (DWORD)SCY2);// --
	SetDWORD(R8(Sacred, 0062FC9A), SCX + 200);//1024+200 cWorldView2::RenderMinObj
	SetDWORD(R8(Sacred, 0062FCB8), SCY + 200);//768+200 --

  
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//----------------------------------------------------------
	// cUI_Manager
	//----------------------------------------------------------
	SetFLOAT(R8(Sacred, 00758D71), gf_1024);//1024.0 cUI_Manager::Render
	SetFLOAT(R8(Sacred, 00758E04), gf_1024);//--
	SetFLOAT(R8(Sacred, 00758EB9), gf_1024);//--
	SetFLOAT(R8(Sacred, 00758F3D), gf_1024);//--
	SetFLOAT(R8(Sacred, 00758EF8), gf_768);//--
	SetFLOAT(R8(Sacred, 00758F45), gf_768);//--
	SetDWORD(R8(Sacred, 0075C18A), (DWORD)SCX2);//512 cUI_Manager_DrawMonsterPopUp
	SetDWORD(R8(Sacred, 0075C1DE), (DWORD)(620 + DCY));//620 --
	SetDWORD(R8(Sacred, 0075C1CF), (DWORD)(620 + DCY));//620 --
	SetDWORD(R8(Sacred, 0075C1B8), (DWORD)(624 + DCY));//624 --
//	SetBytes(R8(Sacred, 0075C046), "6A 02");//font cUI_Manager_DrawMonsterPopUp
	SetBYTE(R8(Sacred, 0075C14D), 8);//Width+8

	//----------------------------------------------------------
	// cEngine
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 0060EB96), (DWORD)SCX);//1024 cEngine::RenderThread
	SetDWORD(R8(Sacred, 0060EB91), (DWORD)SCY);//768 --
	SetFLOAT(R8(Sacred, 0060E48A), gf_1024);//1024.0 cEngine::InModeFade
	SetFLOAT(R8(Sacred, 0060E51D), gf_1024);//--
	SetFLOAT(R8(Sacred, 0060E4DA), gf_768);//768.0 cEngine::InModeFade
	SetFLOAT(R8(Sacred, 0060E525), gf_768);//--

	//----------------------------------------------------------
	// cUI_Tooltip
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 006E805D), (DWORD)SCX);//cUI_Tooltip::AdjustWindowSize
	SetDWORD(R8(Sacred, 006E807A), (DWORD)SCY);//--
	SetDWORD(R8(Sacred, 006E8064), SCX - 32);//--
	SetDWORD(R8(Sacred, 006E8081), SCY - 32);//--
	SetDWORD(R8(Sacred, 006E8097), (DWORD)SCX2);//--
	SetDWORD(R8(Sacred, 006E80AA), (DWORD)SCY2);//--

	//----------------------------------------------------------
	// Help
	//----------------------------------------------------------
	SetNops(R8(Sacred, 0075B242), 0x0075B2A2 - 0x0075B242);		//HCMD_SCREEN
	SetRectangle(R8(Sacred, 017EDAB8), (SCX - 170) / 2, 200, 170, 30);
	SetRectangle(R8(Sacred, 017EDAC4), (SCX - 550) / 2, 250, 550, 200);
	SetRectangle(R8(Sacred, 017EDAD0), (SCX - 300) / 2, 425, 300, 200);

	SetNops(R8(Sacred, 0075B373), 0x0075B4B5 - 0x0075B373);		//HCMD_INVENTORY
	SetNops(R8(Sacred, 0075B368), 5);
	SetRectangle(R8(Sacred, 017ED9A0), DCX, 80, 180, 32);
	SetRectangle(R8(Sacred, 017ED9AC), DCX + 215, 20, 430, 190);
	SetRectangle(R8(Sacred, 017ED9B8), DCX + 215, 135, 430, 182);
	SetRectangle(R8(Sacred, 017ED9C4), DCX + 140, 450, 440, 128);
	SetRectangle(R8(Sacred, 017ED9D0), DCX + 215, 220, 430, 192);
	SetRectangle(R8(Sacred, 017ED9DC), DCX - 45, 667, 170, 16);
	SetRectangle(R8(Sacred, 017ED9E8), DCX + 630, 450, 230, 128);
	SetRectangle(R8(Sacred, 017ED9F4), DCX - 35, 730, 280, 192);
	SetRectangle(R8(Sacred, 017EDA00), DCX + 469, 730, 368, 192);

	SetNops(R8(Sacred, 0075B57E), 0x0075B610 - 0x0075B57E);		//HCMD_BLACKSMITH
	SetNops(R8(Sacred, 0075B56B), 13);
	SetRectangle(R8(Sacred, 017EDA40), DCX + 185, 600, 170, 30);
	SetRectangle(R8(Sacred, 017EDA4C), DCX + 35, 60, 300, 200);
	SetRectangle(R8(Sacred, 017EDA58), DCX + 35, 200, 300, 192);
	SetRectangle(R8(Sacred, 017EDA64), DCX + 345, 250, 280, 128);

	SetNops(R8(Sacred, 0075B6EC), 0x0075B7B5 - 0x0075B6EC);		//HCMD_MASTER_COMBO
	SetNops(R8(Sacred, 0075B56B), 22);
	SetRectangle(R8(Sacred, 017EDAF0), DCX + 215, 600, 170, 30);
	SetRectangle(R8(Sacred, 017EDAFC), DCX + 15, 50, 210, 160);
	SetRectangle(R8(Sacred, 017EDB08), DCX + 325, 300, 250, 160);
	SetRectangle(R8(Sacred, 017EDB14), DCX + 15, 130, 420, 256);
	SetRectangle(R8(Sacred, 017EDB20), DCX + 15, 420, 510, 220);
	SetRectangle(R8(Sacred, 017EDB2C), DCX + 15, 520, 510, 220);

	SetNops(R8(Sacred, 0075B880), 0x0075B937 - 0x0075B880);		//HCMD_MERCHANT
	SetRectangle(R8(Sacred, 017EDA78), DCX + 215, 600, 170, 30);
	SetRectangle(R8(Sacred, 017EDA84), DCX + 65, 45, 220, 200);
	SetRectangle(R8(Sacred, 017EDA90), DCX + 115, 150, 250, 192);
	SetRectangle(R8(Sacred, 017EDA9C), DCX + 215, 420, 250, 128);
	SetRectangle(R8(Sacred, 017EDAA8), DCX + 695, 380, 170, 128);

	SetNops(R8(Sacred, 0075BBA0), 0x0075BC31 - 0x0075BBA0);		//HCMD_MASTER_LOTTO
	SetRectangle(R8(Sacred, 017EDA10), DCX + 285, 600, 170, 30);
	SetRectangle(R8(Sacred, 017EDA1C), DCX + 15, 270, 350, 64);
	SetRectangle(R8(Sacred, 017EDA28), DCX + 15, 100, 350, 300);
	SetRectangle(R8(Sacred, 017EDA34), DCX + 415, 280, 250, 192);

	SetNops(R8(Sacred, 0075BA03), 0x0075BAD3 - 0x0075BA03);		//HCMD_MEGAMAP
	SetNops(R8(Sacred, 0075B9F7), 6);
	SetRectangle(R8(Sacred, 017ED958), (SCX - 170) / 2, DCY + 120, 170, 30);
	SetRectangle(R8(Sacred, 017ED970), (SCX - 900) / 2, DCY + 200, 250, 192);
	SetRectangle(R8(Sacred, 017ED964), (SCX - 900) / 2 + 300, DCY + 200, 300, 200);
	SetRectangle(R8(Sacred, 017ED97C), (SCX - 900) / 2 + 650, DCY + 200, 250, 128);
	SetRectangle(R8(Sacred, 017ED988), DCX, DCY + 600, 300, 192);
	SetRectangle(R8(Sacred, 017ED994), DCX + 470, DCY + 680, 200, 128);

//	SetBytes(R8(Sacred, 0075BDC3), "B9 10 00 00 00");//???		//UIF_HELPTAB

	//----------------------------------------------------------
	// cUI_MainMenu
	//----------------------------------------------------------
	call_ref(R8(Sacred, 0075A224), (DWORD)TheRectangleHCX_STUB); //cUI_Manager::MainMenuLoad
	SetDWORD(R8(Sacred, 00715950), (DWORD)(SCX - 140));//844 button creditsBack
	SetDWORD(R8(Sacred, 00715957), (DWORD)(SCY - 64));//704 button creditsBack
	call_ref(R8(Sacred, 00713232), (DWORD)UI_MAINMENU_InfoUI_STUB);//UI_MAIN_SKY.TGA
	call_ref(R8(Sacred, 007132C9), (DWORD)MainMenu_BackToScreen_STUB);//cUI_MainMenu::Default - [438,448] - gui_optionXX.tga
	SetBytes(R8(Sacred, 00712E71), "D8 0D 80 F9 88 00");//sky-speed 0.005 -> 0.028 cUI_MainMenu::Render
	SetDWORD(R8(Sacred, 00713338), (SCY - 292) / 2 - 24);//238-32 cUI_MainMenu::Default
	SetDWORD(R8(Sacred, 00713349), (SCY - 292) / 2 - 24 - 24);//188-32 -//-
	SetFLOAT(R8(Sacred, 00711AA7), (float)SCY);// creditsY cUI_MainMenu::SetState
	SetFLOAT(R8(Sacred, 007122D9), (float)SCY);// creditsY cUI_MainMenu::ReceiveEvent

	//----------------------------------------------------------
	// Video
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 006A11AC), (DWORD)SCX);//fncGameEnd_PlayMovie
	SetDWORD(R8(Sacred, 006A11E0), (DWORD)SCX);//--

	//----------------------------------------------------------
	// backgrounds
	//----------------------------------------------------------
	call_ref(R8(Sacred, 0071EB7E), (DWORD)BackToScreen_STUB); //cUI_Savegame::Default - UW_option_XX.tga
	call_ref(R8(Sacred, 0071890D), (DWORD)BackToScreen_STUB); //cUI_Options::Init - UW_option_1_XX.tga
	call_ref(R8(Sacred, 0070BB11), (DWORD)BackToScreen_STUB); //cUI_Network::InitBackground - GUI_Option_backgroundXX.tga

	//----------------------------------------------------------
	// cUI_BusyDlg
	//----------------------------------------------------------
	call_ref(R8(Sacred, 0072253D), (DWORD)TheInitFrameBusy_STUB); // cUI_BusyDlg::Init
	call_ref(R8(Sacred, 007222AE), (DWORD)TheInitFrameBusy_STUB); // --
	call_ref(R8(Sacred, 007222DA), (DWORD)TheInitFrameBusy_STUB); // --
	SetDWORD(R8(Sacred, 0072206B), (DWORD)SCX);//fone cUI_BusyDlg::Init
	SetDWORD(R8(Sacred, 00722066), (DWORD)SCY);//fone --
	SetDWORD(R8(Sacred, 00722576), (DWORD)SCX2);//--
	SetDWORD(R8(Sacred, 0072231A), (DWORD)SCX2);//--
	call_ref(R8(Sacred, 007224CE), (DWORD)TheRectBusy_STUB); // --
	call_ref(R8(Sacred, 007221C1), (DWORD)TheRectBusy_STUB); // --

	//----------------------------------------------------------
	// LoadingScreen
	//----------------------------------------------------------
	call_ref(R8(Sacred, 00646C00), (DWORD)TheLoadingScreen_STUB); // dxDriver7::LoadingScreen
//	call_ref(R8(Sacred, 0060AFD0), (DWORD)TheSetCurLoadBmp_STUB); // cEngine::cEngine
//	call_ref(R8(Sacred, 0061A76E), (DWORD)TheSetCurLoadBmp_STUB); // cEngine::SaveGame
//	call_ref(R8(Sacred, 0061BF0D), (DWORD)TheSetCurLoadBmp_STUB); // cEngine::LoadGame
//	call_ref(R8(Sacred, 0081602B), (DWORD)TheSetCurLoadBmp_STUB); // fnInitApp

	//----------------------------------------------------------
	// cUI_OverviewMap
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 006CE3D7), (DWORD)SCX);//1024 cWorld::RenderOverMap
	SetDWORD(R8(Sacred, 006CE3D2), (DWORD)SCY);//768 --

	call_ref(R8(Sacred, 00759A0F), (DWORD)TheRectangleOverviewMap_STUB, 2);
	SetDWORD(R8(Sacred, 006C6D81), HCX + 162);//162 cUI_OverviewMap::Render
	SetDWORD(R8(Sacred, 006C6D89), HCY + 122);//120 --

//	SetBytes(R8(Sacred, 006C6F40), "6A 02");//font -- cUI_OverviewMap::Render
	SetDWORD(R8(Sacred, 006C6F7F), HCX + 170);//170
	SetDWORD(R8(Sacred, 006C6F87), HCY + 124);//124
	SetFLOAT(R8(Sacred, 006C6E0E), (float)SCX2 - 11.0);//501.0
	SetFLOAT(R8(Sacred, 006C6EDF), (float)SCX2 - 11.0);//501.0
	SetFLOAT(R8(Sacred, 006C6E4F), (float)SCX2 + 10.0);//522.0
	SetFLOAT(R8(Sacred, 006C6E97), (float)SCX2 + 10.0);//522.0
	SetFLOAT(R8(Sacred, 006C6E19), (float)SCY2 - 5.0);//379.0
	SetFLOAT(R8(Sacred, 006C6EA2), (float)SCY2 - 5.0);//379.0
	SetFLOAT(R8(Sacred, 006C6E5A), (float)SCY2 + 5.0);//389.0
	SetFLOAT(R8(Sacred, 006C6EEA), (float)SCY2 + 5.0);//389.0

	//----------------------------------------------------------
	// cWorld::RenderOverMap
	//----------------------------------------------------------
	call_ref(R8(Sacred, 006CF0E2), (DWORD)mov_eax_512); //npc
	call_ref(R8(Sacred, 006CF110), (DWORD)add_ecx_512, 1);
	call_ref(R8(Sacred, 006CF102), (DWORD)mov_edx_384);
	call_ref(R8(Sacred, 006CF12F), (DWORD)add_eax_384);

	call_ref(R8(Sacred, 006CF80C), (DWORD)mov_ecx_512); //port,cave
	call_ref(R8(Sacred, 006CF7DA), (DWORD)add_edx_512, 1);
	call_ref(R8(Sacred, 006CF7B6), (DWORD)lea_ecx_384, 1);
	call_ref(R8(Sacred, 006CF7F0), (DWORD)mov_eax_384);

	call_ref(R8(Sacred, 006CF944), (DWORD)mov_ecx_512);
	call_ref(R8(Sacred, 006CF971), (DWORD)mov_edx_384);

	ov768 = 768.0;
	SetDWORD(R8(Sacred, 006CCEE9), (DWORD)&ov768);
	SetDWORD(R8(Sacred, 006CE4B8), (DWORD)&ov768);

	call_ref(R8(Sacred, 006CCEDF), (DWORD)fld_ds_512, 1);
	call_ref(R8(Sacred, 006CFAE2), (DWORD)fadd_ds_512, 1);
	call_ref(R8(Sacred, 006CCEF4), (DWORD)fld_ds_384, 1);
	call_ref(R8(Sacred, 006CE4C5), (DWORD)fld_ds_384, 1);
	call_ref(R8(Sacred, 006CFAFA), (DWORD)fadd_ds_384, 1);
	call_ref(R8(Sacred, 006CE4DD), (DWORD)TheQuestOffset, 2);
	
	SetBYTE(R8(Sacred, 006CCCD3), 0xEB);// alpha < 96

	//----------------------------------------------------------
	// cUI_EscMenu
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 006BB304), (SCX - 264) / 2);//380 cUI_EscMenu::cUI_EscMenu
	SetBytes(R8(Sacred, 006BB322), "90 90");//--
	SetDWORD(R8(Sacred, 006BB31C), (SCY - 200) / 2);//284 cUI_EscMenu::cUI_EscMenu
	SetBytes(R8(Sacred, 006BB324), "90 90");//--
	SetDWORD(R8(Sacred,	006BBA54), (SCX - 264) / 2);//380 cUI_EscMenu::OnShow
	SetBytes(R8(Sacred, 006BBA5A), "90 90");//--
	SetDWORD(R8(Sacred,	006BBA3F), (SCY - 200) / 2);//284 cUI_EscMenu::OnShow
	SetBytes(R8(Sacred, 006BBA5C), "90 90");//--

	//----------------------------------------------------------
	// cUI_Taskbar2
	//----------------------------------------------------------
	call_ref(R8(Sacred, 00759843), (DWORD)TheRectangleHCX_STUB); //UI_WND_TASKBAR
	SetDWORD(R8(Sacred, 0075983E), SCY - 92);//676
	SetFLOAT(R8(Sacred,	00895B08), gf_512 + 1.0);//513.0  cUI_Taskbar2::RenderDayNight
	SetFLOAT(R8(Sacred,	00895B04), gf_768 - 57.5);//710.5  --
	SetFLOAT(R8(Sacred, 00895B18), (float)(SCY - 58));//710.0

	SetDWORD(R8(Sacred, 006E62E4), SCX2 - 77);//435 pot1.x
	SetDWORD(R8(Sacred, 006E62F0), SCX2 - 47);//465 pot2.x
	SetDWORD(R8(Sacred, 006E62FC), SCX2 - 15);//497 pot3.x
	SetDWORD(R8(Sacred, 006E6345), SCX2 + 18);//530 pot4.x
	SetDWORD(R8(Sacred, 006E634D), SCX2 + 48);//560 pot5.x
	SetDWORD(R8(Sacred, 006E62B7), SCY - 101);//667 pot1.y pot5.y
	SetDWORD(R8(Sacred, 006E62BC), SCY - 115);//653 pot2.y pot4.y
	SetDWORD(R8(Sacred, 006E6304), SCY - 119);//649 pot3.y

	SetDWORD(R8(Sacred, 006E64F2), SCX2 - 88);//424 -- pframeL
	SetDWORD(R8(Sacred, 006E6555), SCX2 + 74);//586 -- pframeR
	SetDWORD(R8(Sacred, 006E64E8), SCY - 78);//690 -- pframeL pframeR

	SetDWORD(R8(Sacred, 006E61EA), SCX - 126);//898 -- levelUp
	
	SetFLOAT(R8(Sacred, 006E4629), gf_512);//x 512.0 cUI_Taskbar2::RenderCompass, cConsoleFX::DrawCircle
	SetFLOAT(R8(Sacred, 006E4624), SCY - 57);//y 711.0

	//----------------------------------------------------------
	// cUI_Mercenary
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 00759A6B), (DWORD)(SCX - 96));//932 cUI_Mercenary
	SetDWORD(R8(Sacred, 006D658B), (DWORD)(SCX - 96));//932 cUI_Mercenary::cUI_Mercenary
	SetFLOAT(R8(Sacred, 006D7466), (float)(SCX - 53));//x 975.0 cUI_Mercenary::Render, cConsoleFX::DrawCircle

	//----------------------------------------------------------
	// cUI_Inventory
	//----------------------------------------------------------
	call_ref(R8(Sacred, 0075989E), (DWORD)TheRectangle335_STUB); //cUI_Manager::TaskbarLoad
	SetDWORD(R8(Sacred, 006C5A79), DCX);//cUI_Inventory::cUI_Inventory
	call_ref(R8(Sacred, 006C15EA), (DWORD)TABPAGE_ITEMS_STUB, 2); //cUI_InventoryTab::Render
	call_ref(R8(Sacred, 006C5A9A), (DWORD)TheInventory_LeftBrdPrepare_STUB); //--
	call_ref(R8(Sacred, 006C64C9), (DWORD)TheInventory_LeftBrdRender_STUB); //cUI_Inventory::Render
	call_ref(R8(Sacred, 006C4976), (DWORD)TheSpells1_STUB); //40 cUI_SpellTab::FillSkills
	call_ref(R8(Sacred, 006C4990), (DWORD)TheSpells2_STUB); //112 --
	SetDWORD(R8(Sacred, 006C49AC), 184 + DCX);//184 --
	SetDWORD(R8(Sacred, 006C49C9), 256 + DCX);//256 --
	SetDWORD(R8(Sacred, 006C49E6), 328 + DCX);//328 --
	SetDWORD(R8(Sacred, 006C4A03), 400 + DCX);//400 --
	SetDWORD(R8(Sacred, 006C4A1D), 472 + DCX);//472 --
	SetDWORD(R8(Sacred, 006C4A3D), 136 + DCX);//136 --
	SetDWORD(R8(Sacred, 006C4A5D), 208 + DCX);//208 --
	SetDWORD(R8(Sacred, 006C4A7D), 280 + DCX);//280 --
	SetDWORD(R8(Sacred, 006C4A9A), 352 + DCX);//352 --
	SetDWORD(R8(Sacred, 006C4AB7), 424 + DCX);//424 --
	SetBYTE(R8(Sacred, 006C2ADB), 50);//42 --
	SetBYTE(R8(Sacred, 006C2ADF), 52);//44 --

	//----------------------------------------------------------
	// cUI_Equipment
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 007598F9), 604 + DCX);//604 cUI_Equipment::cUI_Equipment
	SetDWORD(R8(Sacred, 006B65F1), 656 + DCX);// 656
	SetDWORD(R8(Sacred, 006B7FA7), 678 + DCX);//678 cUI_Equipment::Render
	SetDWORD(R8(Sacred, 006B7F81), 680 + DCX);//680--
	SetDWORD(R8(Sacred, 006B7EF9), 680 + DCX);//680--
	SetDWORD(R8(Sacred, 006B7F0D), 680 + DCX);//680--
	SetDWORD(R8(Sacred, 006B7FB2), 680 + DCX);//680--
	SetDWORD(R8(Sacred, 006B807D), 512 + DCX);//512--

	//----------------------------------------------------------
	// cUI_StatisticsChar
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 00759AC7), 576 + DCX);//576 cUI_StatisticsChar::cUI_StatisticsChar
	SetDWORD(R8(Sacred, 006A5FB4), 656 + DCX);//656 --
	SetDWORD(R8(Sacred, 006A6364), 680 + DCX);//680 cUI_StatisticsChar::ReceiveEvent //skills
	SetDWORD(R8(Sacred, 006A6373), 906 + DCX);//780 --
	SetDWORD(R8(Sacred, 006A6449), 662 + DCX);//723 cUI_StatisticsChar::ReceiveEvent //gold
	SetDWORD(R8(Sacred, 006A6454), 906 + DCX);//1567 --

	//----------------------------------------------------------
	// cUI_Merchant
	//----------------------------------------------------------
	call_ref(R8(Sacred, 006DBACA), (DWORD)TheRectangle335_STUB); //cUI_Merchant::cUI_Merchant
	call_ref(R8(Sacred, 006DC71B), (DWORD)TheRectangle335_STUB); //cUI_Merchant::Init
	call_ref(R8(Sacred, 006DC781), (DWORD)TheRectangle335_STUB); //--
	call_ref(R8(Sacred, 006DC7DF), (DWORD)TheRectangle335_STUB); //--
	call_ref(R8(Sacred, 006DBBDA), (DWORD)TheMerchant_LeftBrdRender_STUB); //cUI_Merchant::Render
	call_ref(R8(Sacred, 006D96CD), (DWORD)TABPAGE_WEAPONS_STUB, 1); //cUI_Merchandise::cUI_Merchandise

	//----------------------------------------------------------
	// cUI_Horse
	//----------------------------------------------------------
	call_ref(R8(Sacred, 006BD421), (DWORD)TheRectangleHCX_STUB); //--
//	SetBYTE(R8(Sacred, 006BF092), 1);//font cUI_Horse::Init

	//----------------------------------------------------------
	// cUI_Master
	//----------------------------------------------------------
	call_ref(R8(Sacred, 006D118A), (DWORD)TheRectangle335_STUB); //cUI_Master::cUI_Master
	call_ref(R8(Sacred, 006D1278), (DWORD)TheMaster_LeftBrdRender_STUB); //cUI_Master::Render
	SetDWORD(R8(Sacred, 006D30DD), DCX + 16);//16 cUI_MasterCombo::Render
	SetDWORD(R8(Sacred, 006D4ACD), DCX + 16);//16 --
	SetDWORD(R8(Sacred, 006D533E), 184);//256 --
//	SetBytes(R8(Sacred, 006D12D5), "B8 E0 00 A0 00");//UiTGA --

	//----------------------------------------------------------
	// cUI_Blacksmith
	//----------------------------------------------------------
	call_ref(R8(Sacred, 006A217A), (DWORD)TheRectangle335_STUB); //cUI_Blacksmith::cUI_Blacksmith
	SetWORD(R8(Sacred, 006A2224), DCX + 16);//16 for weapon --
	SetDWORD(R8(Sacred, 006A35A4), DCX + 16);//16 caption cUI_Blacksmith::Init
	SetDWORD(R8(Sacred, 006A5652), DCX + 512);//512 icon1 --
	SetDWORD(R8(Sacred, 006A56C4), DCX + 576);//576 icon2 --
	SetDWORD(R8(Sacred, 006A572F), DCX + 544);//544 icon3 --

	//----------------------------------------------------------
	// cUI_Purchase
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 006DCF2D), DCX + 352);//352 cUI_Purchase::cUI_Purchase
	SetDWORD(R8(Sacred, 006DCFA4), DCX + 160);//160 --
	SetDWORD(R8(Sacred, 006DD21E), DCX + 320);//320 cUI_Purchase::Render

	//----------------------------------------------------------
	// cUI_Chest
	//----------------------------------------------------------
	call_ref(R8(Sacred, 00759D51), (DWORD)TheRectangle335_STUB); //UI_WND_CHEST
	call_ref(R8(Sacred, 006ACD87), (DWORD)TheChest_LeftBrdRender_STUB); //cUI_Chest::Render
	call_ref(R8(Sacred, 006ACEC4), (DWORD)__STUB(1)); //--

	//----------------------------------------------------------
	// cUI_Console
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 00759B26), HCX + 256);//256 cUI_Manager::TaskbarLoad
	SetDWORD(R8(Sacred, 00759B21), SCY - 138);//640 --

	//----------------------------------------------------------
	// cUI_Diary + cUI_Book
	//----------------------------------------------------------
	call_ref(R8(Sacred, 00759B83), (DWORD)TheRectangle230_STUB); //cUI_Diary::cUI_Diary
	int hCX = (SCX - 896) / 2 - 69;
	SetDWORD(R8(Sacred, 006B2D06), (DWORD)(hCX + 150));//150 cUI_Book::Render
	SetDWORD(R8(Sacred, 006B2D1D), (DWORD)(hCX + 170));//170 --
	SetDWORD(R8(Sacred, 006B2CD0), (DWORD)(hCX + 220));//220 --
	SetDWORD(R8(Sacred, 006B2CF2), (DWORD)(hCX + 550));//550 --
	SetBYTE(R8(Sacred, 006B243F), 12);//x+8 cUI_Book::RenderPag

	//----------------------------------------------------------
	// cUI_TextLines
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 007228C4), (DWORD)SCX);//1024 cUI_TextLines::cUI_TextLines
	SetDWORD(R8(Sacred, 007228Bf), (DWORD)SCY);//768 --
	SetWORD(R8(Sacred, 00722E24), (WORD)SCX);//1024 UI_TextLines::Render

	//----------------------------------------------------------
	// cUI_Megamap
	//----------------------------------------------------------
	//megamap - cUI_Manager::TaskbarLoad -> cRectangle::cRectangle
	SetDWORD(R8(Sacred, 007599B2), (DWORD)SCX);//UI_WND_MEGAMAP.cx 1024=1366
	SetDWORD(R8(Sacred, 007599AD), (DWORD)SCY);//UI_WND_MEGAMAP.cy 768= --
	
	//frame - cUI_Megamap::DefaultMegamap -> cUI_Window::InitFrame
	DWORD fx = (SCX - 80) / 32;
	DWORD fy = (SCY - 86) / 32;
	DWORD frame_cx = fx * 32;
	DWORD frame_cy = fy * 32;
	DWORD frame_x = (SCX - frame_cx) / 2;
	DWORD frame_y = (SCY - frame_cy) / 2;
	DWORD min_xy = __min(frame_x, frame_y);
	SetDWORD(R8(Sacred, 006CB91F), (DWORD)min_xy);//frame.x, frame.y 48=
	SetWORD(R8(Sacred, 006CB93C), (WORD)frame_cx);//frame.cx 928=
	SetWORD(R8(Sacred, 006CB943), (WORD)frame_cy);//frame.cy 672=
	
	//taskbar - cUI_Megamap::DefaultMegamap
	DWORD taskbarLR_y = min_xy + frame_cy + 30;
	SetDWORD(R8(Sacred, 006CB6EB), (DWORD)taskbarLR_y);//taskbarL.y 750
	SetDWORD(R8(Sacred, 006CB755), (DWORD)taskbarLR_y);//taskbarR.y 750

	//buttons - cUI_Megamap::DefaultMegamap
	DWORD mtbB1_x = 432 + HCX;
	DWORD mtbB3_x = 558 + HCX;
	DWORD mtbB1_y = taskbarLR_y - 65;
	DWORD mtbB3_y = taskbarLR_y - 65;
	SetDWORD(R8(Sacred, 006CB793), (DWORD)mtbB1_x);//mtbB1.x 432
	SetDWORD(R8(Sacred, 006CB84F), (DWORD)mtbB3_x);//mtbB3.x 558
	SetDWORD(R8(Sacred, 006CB7AF), (DWORD)mtbB1_y);//mtbB1.y 685
	SetDWORD(R8(Sacred, 006CB86B), (DWORD)mtbB3_y);//mtbB3.y 685

	//mouse in megamap
	DWORD SCX1 = SCX - 1;
	SetDWORD(R8(Sacred, 006CA130), (DWORD)SCX1);//cUI_Megamap::Render
	SetDWORD(R8(Sacred, 006CA156), (DWORD)SCX1);//--
	SetDWORD(R8(Sacred, 006CA194), (DWORD)SCX1);//--
	SetDWORD(R8(Sacred, 006C7A3B), (DWORD)SCX1);//cUI_Megamap::SetMouseCursor
	SetDWORD(R8(Sacred, 006C7A60), (DWORD)SCX1);//--
	SetDWORD(R8(Sacred, 006C7A9C), (DWORD)SCX1);//--
	DWORD SCY1 = SCY - 1;
	SetDWORD(R8(Sacred, 006CA147), (DWORD)SCY1);//cUI_Megamap::Render
	SetDWORD(R8(Sacred, 006CA15E), (DWORD)SCY1);//--
	SetDWORD(R8(Sacred, 006CA178), (DWORD)SCY1);//--
	SetDWORD(R8(Sacred, 006C7A51), (DWORD)SCY1);//cUI_Megamap::SetMouseCursor
	SetDWORD(R8(Sacred, 006C7A67), (DWORD)SCY1);//--
	SetDWORD(R8(Sacred, 006C7A80), (DWORD)SCY1);//--

	//validRect - cUI_Megamap::Render
	SetDWORD(R8(Sacred, 006CA23E), (DWORD)(-SCX));//-1024
	SetDWORD(R8(Sacred, 006CA268), (DWORD)(-SCY));//-768

	// ltopX, ltopY - cUI_Megamap::RenderMap
	SetDWORD(R8(Sacred, 006C9E05), (DWORD)SCX);//1024
	SetDWORD(R8(Sacred, 006C9E15), (DWORD)SCY);//768
	SetDWORD(R8(Sacred, 006C9E68), (DWORD)SCY);//768

	//center - cUI_Megamap::Render
	SetDWORD(R8(Sacred, 006CA8A0), (DWORD)SCX2);//512
	SetDWORD(R8(Sacred, 006CA8BC), (DWORD)SCY2);//384
	SetDWORD(R8(Sacred, 006CA9A6), (DWORD)SCX2);//512
	SetDWORD(R8(Sacred, 006CA99F), (DWORD)SCY2);//384
	SetDWORD(R8(Sacred, 006CA999), (DWORD)SCX2);//512
	SetDWORD(R8(Sacred, 006CA990), (DWORD)SCY2);//384

	//text - cUI_Megamap::Render
	SetDWORD(R8(Sacred, 006CA628), (DWORD)SCX);//1024
	SetDWORD(R8(Sacred, 006CA647), (DWORD)SCX);//1024

	//edge blur frame - cUI_Megamap::Render
	SetFLOAT(R8(Sacred, 006CAADB), (float)SCX);//4 1024.0
	SetFLOAT(R8(Sacred, 006CAB6F), (float)SCX);//6 1024.0
	SetFLOAT(R8(Sacred, 006CAB23), (float)(SCX - 70));//5 954.0
	SetFLOAT(R8(Sacred, 006CABB3), (float)(SCX - 70));//7 954.0
	SetFLOAT(R8(Sacred, 006CAA52), (float)SCY);//2 768.0
	SetFLOAT(R8(Sacred, 006CAAE6), (float)SCY);//4 768.0
	SetFLOAT(R8(Sacred, 006CAA9A), (float)(SCY - 70));//3 698.0
	SetFLOAT(R8(Sacred, 006CAB2E), (float)(SCY - 70));//5 698.0

	//----------------------------------------------------------
	// cUI_Character
	//----------------------------------------------------------
	call_ref(R8(Sacred, 00710076), (DWORD)BackToScreen_STUB); //cUI_Character::Init
	SetDWORD(R8(Sacred, 0070BE70), (DWORD)SCX);//--
	SetDWORD(R8(Sacred, 0070BE6B), (DWORD)SCY);//--
	SetFLOAT(R8(Sacred, 006F21C6), gf_512);//442AC000 512.0 fnsUI_NetGranny_Draw
	SetFLOAT(R8(Sacred, 006F21CB), gm_512);//C42AC000 -512.0 
	SetFLOAT(R8(Sacred, 006F21BC), gf_384);//442AC000 384.0
	SetFLOAT(R8(Sacred, 006F21C1), gm_384);//C42AC000 -384.0 
	SetDWORD(R8(Sacred, 0071027E), (DWORD)(HCX + 320));//320
	SetDWORD(R8(Sacred, 0071029F), (DWORD)(HCX + 300));//300
	SetDWORD(R8(Sacred, 00710286), SCY - 185);//583
	SetDWORD(R8(Sacred, 007102AE), SCY - 85);//683
	SetWORD(R8(Sacred, 0070F0FD), (WORD)SCX);//1024
	SetDWORD(R8(Sacred, 006F0A72), (DWORD)SCX);//1024
	SetDWORD(R8(Sacred, 0070F2FC), (DWORD)(HCX + 316));//316
	SetDWORD(R8(Sacred, 0070F304), SCY - 206);//562
//	SetBytes(R8(Sacred, 006F158E), "6A 05");//font UI_SAVE_EMPTY
	SetDWORD(R8(Sacred, 006F163D), 0xFFC07000);//color --
	SetFLOAT(R8(Sacred, 00895CD4), (float)(atan((double)SCX / 73.530141 / 20.0) * 2.0 / 69.7));//f_0_0174533
	SetBytes(R8(Sacred, 006F51F3), "D8 0D D4 5C 89 00");//cUI_NetGranny::InitPerspectiveMatrix
	SetBytes(R8(Sacred, 00710236), "D8 0D D4 5C 89 00");//cUI_Character::Init
	SetFLOAT(R8(Sacred, 00895B1C), (float)(atan((double)SCY / 78.254468 / 20.0) * 2.0 / 69.7));//f_0_01308997
	SetBytes(R8(Sacred, 006F51E3), "D8 0D 1C 5B 89 00");//cUI_NetGranny::InitPerspectiveMatrix
	SetBytes(R8(Sacred, 00710226), "D8 0D 1C 5B 89 00");//cUI_Character::Init
	SetModels();

	//----------------------------------------------------------
	// cUI_NetworkInfo
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 006F6CAB), (SCX - 320)/2);//352 -- cUI_NetworkInfo::cUI_NetworkInfo
	SetDWORD(R8(Sacred, 006F6CA6), SCY - 362);//406 --
	SetDWORD(R8(Sacred, 006F785C), (DWORD)(HCX + 256));//rect4P.x 256 cUI_NetworkInfo::Render
	SetDWORD(R8(Sacred, 006F7866), (DWORD)(SCY - 262));//rect4P.y 506 cUI_NetworkInfo::Render
	SetDWORD(R8(Sacred, 006F784D), (DWORD)(HCX + 256));//rect8P.x 256 --
	SetDWORD(R8(Sacred, 006F7848), (DWORD)(SCY - 362));//rect8P.y 406 --
	call_ref(R8(Sacred, 006F7897), (DWORD)TheRectangleHCX_STUB);//rect16P --
	SetDWORD(R8(Sacred, 006F788C), (DWORD)(SCY - 362));//rect16P.y 406 --
	SetBytes(R8(Sacred, 006F7931), "83 C0 02");//y+8 --
	SetDWORD(R8(Sacred, 006F7026), (DWORD)(HCX + 256));//chat 256=427 cUI_NetworkInfo::ResizeWindowRect
	SetBytes(R8(Sacred, 006F7068), "6A 02");//chat dy
	call_ref(R8(Sacred, 006F7C4A), R8(Sacred, 00673360));//cScriptLoader::GetUiResourceW
	call_ref(R8(Sacred, 006F7C59), R8(Sacred, 0041E7F0));//STRW_copy
	SetBytes(R8(Sacred, 006F7C6B), "FF 52 10");//cFontTTF_DrawTextSTRW --
	SetDWORD(R8(Sacred, 006D03D7), (DWORD)SCX);//1024 cUI_NetworkInfo::RenderHudArrow
	SetDWORD(R8(Sacred, 006D03DC), (DWORD)SCY);//768 --
	SetDWORD(R8(Sacred, 006D0973), 0x00FFFFFF);//bk color --
	SetBYTE(R8(Sacred, 006D0AC0), 2);//dy --
	SetBYTE(R8(Sacred, 006D0AC3), 0);//dx --
	SetBYTE(R8(Sacred, 006D0A52), 2);//dy --
	SetBYTE(R8(Sacred, 006D0A4F), 0);//dy --
	// Lan chat
	SetBytes(R8(Sacred, 006FCD9F), "6A 00");//oy --
	SetBYTE(R8(Sacred, 006FCDE2), 62);

	//----------------------------------------------------------
	// cUI_NetPortrait
	//----------------------------------------------------------
	call_ref(R8(Sacred, 006D922A), (DWORD)TheNetPortraitY_STUB);//UI_WND_NETPORTRAIT.y
	SetDWORD(R8(Sacred, 006D92C5), 50);//18 UI_WND_NETPORTRAIT.y level, name

	//----------------------------------------------------------
	// cUI_Trade
	//----------------------------------------------------------
//	SetBytes(R8(Sacred, 006EC488), "6A 02");// sub_6EC380, cUI_Manager::AddTextLine 16 = 0xFFFF0000 UI_TRADE_CANT_TRADE
	SetBytes(R8(Sacred, 00722B9C), "83 44 24 38 00");//110=56 cUI_TextLines::Render
	call_ref(R8(Sacred, 00722B54), (DWORD)TheChatText1_STUB, 3);
	call_ref(R8(Sacred, 00722BAD), (DWORD)TheChatText2_STUB, 3);
	//RenderFrom as button
	SetDWORD(R8(Sacred, 0075C75D), (DWORD)(SCY - 152));//620
	call_ref(R8(Sacred, 0075C74D), (DWORD)TheRenderFrom_STUB);
	call_ref(R8(Sacred, 0075C7BA), (DWORD)TheRenderFromColor_STUB, 2);
	call_ref(R8(Sacred, 0075C7B5), (DWORD)__STUB(10));
	SetBYTE(R8(Sacred, 0075C747), 0);
	//trade
	call_ref(R8(Sacred, 00759EEF), (DWORD)TheRectangle335_STUB);
	call_ref(R8(Sacred, 006EAAD5), (DWORD)TheTrade_LeftBrdRender_STUB);
	SetWORD(R8(Sacred, 006E9268), (WORD)(63+DCX));//63 inv26
	SetWORD(R8(Sacred, 006E928E), (WORD)(363+DCX));//363 inv27
	SetDWORD(R8(Sacred, 006EB75F), (DWORD)(48+DCX));//48 inv26 frame
	call_ref(R8(Sacred, 006EB7EC), (DWORD)TheTrade92_STUB, 1);// inv27 frame
	call_ref(R8(Sacred, 006EB879), (DWORD)TheTrade48A_STUB, 3);// 
	call_ref(R8(Sacred, 006EB8DF), (DWORD)TheTrade92A_STUB, 5);// 
	call_ref(R8(Sacred, 006EB954), (DWORD)TheTrade33_STUB, 4);// 
	call_ref(R8(Sacred, 006EB9C1), (DWORD)TheTrade16_STUB, 4);// 
	SetDWORD(R8(Sacred, 006EBA93), (DWORD)(126+DCX));//126
	SetDWORD(R8(Sacred, 006EBAFE), (DWORD)(48+DCX));//48
	SetDWORD(R8(Sacred, 006EBB69), (DWORD)(348+DCX));//348
	SetDWORD(R8(Sacred, 006EB2CC), (DWORD)(470+DCX));//470
	call_ref(R8(Sacred, 006EB028), (DWORD)TheRectangle335_STUB);
	call_ref(R8(Sacred, 006EB1B0), (DWORD)TheRectangle335_STUB);
	call_ref(R8(Sacred, 006EB0CF), (DWORD)TheRectangleAdd335_STUB);
	call_ref(R8(Sacred, 006EB2A5), (DWORD)TheRectangleAdd335_STUB);

	//----------------------------------------------------------
	// Screenshot
	//----------------------------------------------------------
	//dxDriver7::Flip
	call_ref(R8(Sacred, 0064623E), (DWORD)TheScreenshot_BackSurface_STUB, 1);

	//cScreenshot::SaveTGA
	SetDWORD(R8(Sacred, 00648633), (DWORD)SCX);//1024
	SetDWORD(R8(Sacred, 0064864D), (DWORD)SCY);//768
	call_ref(R8(Sacred, 006609CD), (DWORD)TheScreenshot_Pitch_STUB, 4);
	call_ref(R8(Sacred, 00648637), (DWORD)TheScreenshot_Depth_STUB, 1);
	SetWORD(R8(Sacred, 006486BE), (WORD)SCY);//768
	SetDWORD(R8(Sacred, 006486D9), (DWORD)SCY);//768
	call_ref(R8(Sacred, 006486DD), (DWORD)TheScreenshot001_STUB, 2);//(SCY-1)*pitch
	call_ref(R8(Sacred, 00648740), (DWORD)TheScreenshot002_STUB);
	call_ref(R8(Sacred, 0064875B), (DWORD)TheScreenshot003_STUB);

	//cScreenshot::JpgUploadThread
	DWORD jpg_size = SCX * SCY * 4;
	SetDWORD(R8(Sacred, 006488DE), (DWORD)SCX);//jcp.DIBWidth,jcp.JPGWidth; 1024
	SetDWORD(R8(Sacred, 006488B6), (DWORD)SCY);//jcp.DIBHeight,jcp.JPGHeight; 768
	SetDWORD(R8(Sacred, 00648906), jpg_size);//jcp.JPGSizeBytes;
	SetDWORD(R8(Sacred, 006487E4), jpg_size);//operator new[];
	SetDWORD(R8(Sacred, 00648828), jpg_size);//while();

	//----------------------------------------------------------
	// Mini-Screenshot
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 00613B29), SCX);//1024 cEngine::CaptureInternal
	SetDWORD(R8(Sacred, 00613AFF), SCX);//1024 --
	SetDWORD(R8(Sacred, 00613AD2), SCX);//1024 --
	SetDWORD(R8(Sacred, 00613AAF), SCX);//1024 --
	SetDWORD(R8(Sacred, 00613B24), SCY);//768 --
	SetDWORD(R8(Sacred, 00613AFA), SCY);//768 --
	SetDWORD(R8(Sacred, 00613ACD), SCY);//768 --
	SetDWORD(R8(Sacred, 00613AAA), SCY);//768 --
	call_ref(R8(Sacred, 006139CC), (DWORD)TheCaptureScreenSize_STUB, 1);//SCX*SCY*(depth/8) --
	call_ref(R8(Sacred, 00613A34), (DWORD)TheCaptureScreenLineSize_STUB, 6);//SCX*(depth/8) --
	SetBYTE(R8(Sacred, 00660DF6), 0x1F);//0x1E gfx565to555

	//----------------------------------------------------------
	// cWeatherManager
	//----------------------------------------------------------
	SetDWORD(R8(Sacred, 0041B230), (DWORD)SCX);// cWeatherManager::Hilight_AddPositionCrt
	SetDWORD(R8(Sacred, 0041B246), (DWORD)SCX2);// --
	SetDWORD(R8(Sacred, 0041B263), (DWORD)SCY2);// --
	SetDWORD(R8(Sacred, 0041B2CE), (DWORD)SCX);// cWeatherManager::Hilight_AddPosition_Iso
	SetDWORD(R8(Sacred, 0041B31E), (DWORD)SCX2);// --
	SetDWORD(R8(Sacred, 0041B340), (DWORD)SCY2);// --
	SetDWORD(R8(Sacred, 0041B4B7), (DWORD)SCX2);// cWeatherManager::Hilight_GetIntensity_wp
	SetDWORD(R8(Sacred, 0041B4A5), (DWORD)SCY2);// --
	SetDWORD(R8(Sacred, 0041B597), (DWORD)SCX2);// cWeatherManager::Hilight_GetColor_wp
	SetDWORD(R8(Sacred, 0041B585), (DWORD)SCY2);// --

	SetBytes(R8(Sacred, 004197F0), "90 90 90 90 90");// snow cWeatherManager::Render
	SetBytes(R8(Sacred, 004197E7), "90 90 90 90");// --
	SetBytes(R8(Sacred, 00419809), "90 90 90 90 90");// --
	SetBytes(R8(Sacred, 00419800), "90 90 90 90");// --


	// cWorldView2.uvCoords
	SetBytes(R8(Sacred, 00624A6D), "90 90 90 90");
	call_ref(R8(Sacred, 00624A71), (DWORD)TheCoords_STUB);
	jmp_near_ref(R8(Sacred, 00624A76), R8(Sacred, 00624BA7));

}