
#include "../../../defs.h"
#include "../../mod_defs.h"
#include "../../mod_functions.h"
#include "../../mod_variables.h"
////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------------------------ screen.x, screen.y
int g_scx, g_scy, SCX, SCY, SCX2, SCY2, DCX, DCY, HCX, HCY;

void Install_ScreenDimensions(int nScx, int nScy)
{
	SCX = nScx;				// scx = screen.x
	SCY = nScy;				// scy = screen.y
	SCX2 = SCX / 2;			// scx2 = scx / 2
	SCY2 = SCY / 2;			// scy2 = scy / 2
	DCX = SCX - 1024;		// dcx = scx - 1024
	HCX = DCX / 2;			// hcx = (scx - 1024) / 2;	
	DCY = SCY - 768;		// dcy = scy - 768;
	HCY = DCY / 2;			// hcy = (scy - 768) / 2;
	
	OverviewInit(SCX2, SCY2);
}

//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
void DefaultVariables()
{
	g_isKlick = FALSE;

	// patch
	cWeatherManager_Instance()->maxX = (*g_dxDriver7)->mode.ddsd.dwWidth;
}

//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
void __stdcall OnInitApp(HWND hWnd, cUI_Manager* pUIMng)
{
	//ToDo

	//-----------------------------------
	cUI_Manager_SetActiveMainmenu(pUIMng);
}
NAKED_FUNC(dw874221, TheInitApp_STUB)
{
	mov eax, [esp+4CE8Ch]
	push ecx
	push eax
	call OnInitApp
	END_FUNC(dw874221)
}

//----------------------------------------------------------------------
void __stdcall TheOnWindowProc_Engine(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static POINTS m;
	HWND hWnd = (*g_dxDriver7)->hWnd;

	//ToDo

}
NAKED_FUNC(dw873635, TheOnWindowProc_Engine_STUB)
{
	push edi
	push ebp
	push esi
	call TheOnWindowProc_Engine
	cmp esi, 202h
	END_FUNC(dw873635)
}


//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
void __stdcall OnReceiveEventUI(cEventUI2* pEvt, cMutex* mutex)
{
	//ToDo

	//-----------------------------------
	cMutex_MutexOff(mutex);
}
NAKED_FUNC(dw874222, OnReceiveEventUI_STUB)
{
	push ecx
	push edi
	call OnReceiveEventUI
	END_FUNC(dw874222)
}



//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
char __cdecl OnBalanceLoad(char* fname)
{
	char rez = cBalance_Load(fname);

	//ToDo

	return rez;
}

NAKED_FUNC(dw77466b, OnBalanceLoad_STUB)
{
	call OnBalanceLoad
	END_FUNC(dw77466b)
}

//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
DWORD g_dwGameSession = 1;
void __stdcall OnEngineConstructor(cEngine* pEng)
{
	DefaultVariables();
}
NAKED_FUNC(dw77364e, TheEngineConstructor_STUB)
{
	push ebp
	call OnEngineConstructor
	mov ecx, [esp+38Ch]
	END_FUNC(dw77364e)
}
void __stdcall OnEngineDestructor()
{
	g_dwGameSession++;
}
NAKED_FUNC(dw77365e, TheEngineDestructor_STUB)
{
	call OnEngineDestructor
	mov ecx, [esp+14h]
	pop edi
	END_FUNC(dw77365e)
}


//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
char __stdcall On_BeginScene(int nScreen, dxDriver7* pDir)
{
	//-----------------------------------------------------------------------------
	// Main Menu screen
	//-----------------------------------------------------------------------------
	if(nScreen == 1)
	{
		//ToDo
	}

	//-----------------------------------------------------------------------------
	// Game screen
	//-----------------------------------------------------------------------------
	if(nScreen == 2)
	{
		//ToDo
	}

	//--------------------------
	return dxDriver7_BeginScene(pDir);
}
NAKED_FUNC(dw12345m, OnManagerThread_BeginScene_STUB)
{
	push ecx
	push 1
	call On_BeginScene
	END_FUNC(dw12345m)
}
NAKED_FUNC(dw12345e, OnEngineThread_BeginScene_STUB)
{
	push ecx
	push 2
	call On_BeginScene
	END_FUNC(dw12345e)
}

//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
void Install_OnXXX()
{
	call_ref(R8(Sacred, 0081665A), (DWORD)TheInitApp_STUB);
	call_ref(R8(Sacred, 0060D805), (DWORD)TheEngineConstructor_STUB, 2);
	call_ref(R8(Sacred, 0060D993), (DWORD)TheEngineDestructor_STUB);
	call_ref(R8(Sacred, 007589E4), (DWORD)OnReceiveEventUI_STUB);
//	call_ref(R8(Sacred, 00811357), (DWORD)TheOnWindowProc_Engine_STUB, 1);
	call_ref(R8(Sacred, 00815D4C), (DWORD)OnBalanceLoad_STUB);


//	call_ref(R8(Sacred, 00756E87), (DWORD)OnManagerThread_BeginScene_STUB);
//	call_ref(R8(Sacred, 0060EB69), (DWORD)OnEngineThread_BeginScene_STUB);


}













