// mod_functions.h : header file
//

#pragma once
#pragma warning(disable: 4035)
////////////////////////////////////////////////////////////////////////////

#include "mod_defs.h"
////////////////////////////////////////////////////////////////////////////


#define X7(Z, G, X, R, N, P)	typedef R (X *T##N) P; extern T##N N;
#define Y7(Z, G, X, R, N, P)	typedef R (X *T##N) P; extern T##N N;
#define Y8(Z, G, X, R, N, P)	typedef R (X *T##N) P; extern T##N N;

#define __mov(R, N)					__asm { mov R, dword ptr [ebp + N] }
#define __push(N)					__asm { push dword ptr [ebp + N] }

#define R1(r1)						__mov(r1, 8)
#define R2(r1, r2)					__mov(r1, 8) __mov(r2, 12)
#define R3(r1, r2, r3)				__mov(r1, 8) __mov(r2, 12) __mov(r3, 16)
#define R4(r1, r2, r3, r4)			__mov(r1, 8) __mov(r2, 12) __mov(r3, 16) __mov(r4, 20)
#define R5(r1, r2, r3, r4, r5)		__mov(r1, 8) __mov(r2, 12) __mov(r3, 16) __mov(r4, 20) __mov(r4, 24)

#define H1(N)						__push(N)
#define H2(N)						__push(N + 4)  __push(N)
#define H3(N)						__push(N + 8)  __push(N + 4)  __push(N)
#define H4(N)						__push(N + 12) __push(N + 8)  __push(N + 4)  __push(N)
#define H5(N)						__push(N + 16) __push(N + 12) __push(N + 8)  __push(N + 4)  __push(N)
#define H6(N)						__push(N + 20) __push(N + 16) __push(N + 12) __push(N + 8)  __push(N + 4)  __push(N)
#define H7(N)						__push(N + 24) __push(N + 20) __push(N + 16) __push(N + 12) __push(N + 8)  __push(N + 4)  __push(N)
#define H8(N)						__push(N + 28) __push(N + 24) __push(N + 20) __push(N + 16) __push(N + 12) __push(N + 8)  __push(N + 4)  __push(N)
#define H9(N)						__push(N + 32) __push(N + 28) __push(N + 24) __push(N + 20) __push(N + 16) __push(N + 12) __push(N + 8)  __push(N + 4) __push(N)
#define H10(N)						__push(N + 36) __push(N + 32) __push(N + 28) __push(N + 24) __push(N + 20) __push(N + 16) __push(N + 12) __push(N + 8) __push(N + 4) __push(N)
#define H11(N)						__push(N + 40) __push(N + 36) __push(N + 32) __push(N + 28) __push(N + 24) __push(N + 20) __push(N + 16) __push(N + 12) __push(N + 8) __push(N + 4) __push(N)
#define H12(N)						__push(N + 44) __push(N + 40) __push(N + 36) __push(N + 32) __push(N + 28) __push(N + 24) __push(N + 20) __push(N + 16) __push(N + 12) __push(N + 8) __push(N + 4) __push(N)

#define R1H(r1, h)					R1(r1) H##h(12)
#define R2H(r1, r2, h)				R2(r1, r2) H##h(16)
#define R3H(r1, r2, r3, h)			R3(r1, r2, r3) H##h(20)
#define R4H(r1, r2, r3, r4, h)		R4(r1, r2, r3, r4) H##h(24)
#define R5H(r1, r2, r3, r4, r5, h)	R5(r1, r2, r3, r4, r4) H##h(28)

#define U8(Z, G, X, R, N, P, S)	typedef R (*T##N) P; extern T##N U##N; \
								inline R N P { S __asm { call U##N } __asm { mov eax, X } }

#define NOCALL(H, N, D)	DWORD dw##D; void __NAKED N() { __asm {	pop dw##D } __asm { add esp, 4*H } __asm { jmp dw##D } }


#include "Game/gFuncs.h"

#undef X7
#undef Y7
#undef Y8
#undef U8

//----------------------------------------------------------------------
BOOL InitGameFunctions();


//----------------------------------------------------------------------
void __stdcall arg0();
void __stdcall arg1(int);
void __stdcall arg2(int, int);
void __stdcall arg3(int, int, int);
void __stdcall arg4(int, int, int, int);
void __stdcall arg5(int, int, int, int, int);
void __stdcall arg6(int, int, int, int, int, int);
void __stdcall arg7(int, int, int, int, int, int, int);
void __stdcall arg8(int, int, int, int, int, int, int, int);
void __stdcall arg9(int, int, int, int, int, int, int, int, int);
void __stdcall arg10(int, int, int, int, int, int, int, int, int, int);
void __stdcall arg11(int, int, int, int, int, int, int, int, int, int, int);
#define __STUB(a)	(DWORD)arg##a

#define __ret0	"C3"
#define __ret1	"C2 04 00"
#define __ret2	"C2 08 00"
#define __ret3	"C2 0C 00"
#define __ret4	"C2 10 00"
#define __ret5	"C2 14 00"
#define __ret6	"C2 18 00"
#define __ret7	"C2 1C 00"
#define __ret8	"C2 20 00"
#define __ret9	"C2 24 00"
#define __ret10	"C2 28 00"
#define __ret11	"C2 2C 00"
#define __RET(a)	__ret##a





