// mod_libraries.h : header file
//

#ifndef __LIBRARIES_H__
#define __LIBRARIES_H__
#pragma once
////////////////////////////////////////////////////////////////////////////

#include "mod_defs.h"
#include "Game/gLib.h"
////////////////////////////////////////////////////////////////////////////


//----------------------------------------------------------------------
extern DWORD g_dwSacred;		extern DWORD g_dwSacred_Base;
extern DWORD g_dwGameServ;		extern DWORD g_dwGameServ_Base;
extern DWORD g_dwGranny;		extern DWORD g_dwGranny_Base;

//----------------------------------------------------------------------
#define _LibStr(lib)		( GameLibStr[lib] )
char* GetGameLibStr(int lib);

//----------------------------------------------------------------------
DWORD _Lib_LoadLibrary(LPCSTR pszLibraryName, DWORD* pdwLibraryBase);
void _Lib_FreeLibrary(LPCSTR pszLibraryName, DWORD dwOffset);
void _Lib_HookLibrary(LPCSTR pszLibraryName, DWORD dwAddr, BOOL isLog);
void _Lib_UnhookLibrary(LPCSTR pszLibraryName, DWORD dwAddr);
void _Lib_LoadGameLibraries();
void _Lib_FreeGameLibraries();
void _Lib_HookGameLibraries(BOOL isLog);
void _Lib_UnhookGameLibraries(BOOL isLog);


////////////////////////////////////////////////////////////////////////////
#endif // __LIBRARIES_H__