#pragma once

#include "stdafx.h"
#include <windows.h>
#include "Service/error.h"
//#include "resource.h"
////////////////////////////////////////////////////////////////////////////

#define DLL_VERSION		"1.10"
#define GAME_VERSION	"2.28"
#define GAME_NAME		"Sacred"
#define DLL_NAME		"pHD"
#define LOG_FILE		DLL_NAME ".log"

//----------------------------------------------------------------------
#define CONSOLE_STUB
//#define NOWIN_NOMOVIE


//----------------------------------------------------------------------
#define RATIO_HD	1.333984375

extern char g_module_path[260];
extern char g_capture_path[260];
extern HMODULE g_hInstance;
extern HANDLE g_hBmpPHD;

extern DWORD g_nnnn, g_iiii, g_mmmm;
extern float g_ffff;
extern DWORD g_K;
extern double g_dK;

extern HFONT g_hFont;
extern BOOL g_isKlick;
extern int g_scx;
extern int g_scy;

extern wchar_t* g_wszBufferService;
extern char* g_szBufferService;
extern DWORD gx1, gy1, gz1, gx2, gy2, gz2;

extern char* g_aString;
extern wchar_t* g_wString;


//----------------------------------------------------------------------
void GlobalBuffers_Alloc();
void GlobalBuffers_Free();

//------------------------------------------------------------------------------------------------------------ MsgBoxA
inline BOOL MsgBoxA(LPSTR aFormat, ...)
{
	if(strlen(aFormat) <= 0) return FALSE;

	LPSTR aString = new char[65536];
	memset(aString, 0, 65536);
	va_list vaArgs;

	va_start(vaArgs, aFormat);
	vsprintf(aString, aFormat, vaArgs);
	va_end(vaArgs);

	::MessageBox(NULL, aString, "Info", MB_OK);

	delete[] aString;
	return TRUE;
}