// virtual.h : header file
//

#pragma pack(1)
////////////////////////////////////////////////////////////////////////////
#define __thiscall

struct cUI_Manager;
struct cFontTTF2;
struct FontFS;
struct FontTTF;
struct IDirect3DDevice7;
struct cRectangle;
struct cEngine;
struct cCreature;
struct STR_A;
struct STR_W;
struct sWeaponInfo;
struct FileRam;
struct cFile;
struct cParticleSystem;
struct sWeaponInfo_vector;
/*
struct 
struct 
struct 
struct 
struct 
struct 
struct 
struct 
*/

struct cTimerListener;
struct cObject;
struct cObject3D;
struct cItemBase;
struct cArmor3D;
struct cWorldPosition;

struct cEvent;
struct cEventIdle;				// 0.0
struct cEventMouseMove;			// 1.0
struct cEventMouseButtonDown;	// 2.0
struct cEventMouseButtonUp;		// 3.0
struct cEventKey;				// 4.0
struct cEventUI2;				// 5.16
struct cEventUI_String;			// 5.17
struct cEventEngine;			// 6.32
struct cEventTrigger;			// 6.33
struct cEventObject;			// 6.34
struct cEventWeather;			// 6.36
struct cEventConsole;			// 6.37
struct cEventCreature;			// 7.35
struct cEventFX;				// 8.0
struct cEventArrow;				// 9.0
struct cEventNetwork;			// 10.0
struct cEventProfile;			// 11.0
struct cEventIME;				// 12.0




struct cRectangle;
struct UI_StaticText64;
struct cUI_Button;
struct cUI_Control;
struct cUI_Static;
struct cUI_Scrollbar;
struct cUI_Listbox;


struct UI_Window;




// .?AVcUI_Manager@: .?AVcKernelListener@
struct AVcUI_Manager //sizeof=0xC
{
	void (__thiscall *cUI_Manager_EventListener)(cUI_Manager*, cEvent*);
	int (__thiscall *cUI_Manager_Free)(cUI_Manager*, int);
	int (__thiscall *cUI_Manager_ToolReceiveEvent)(cUI_Manager*, cEvent*);
};

// .?AVcKernelListener@
struct AVcKernelListener //sizeof=0x4
{
	void* __purecall;
};

// .?AVcEngine@: .?AVcKernelListener@
struct AVcEngine //sizeof=0x8
{
	void (__thiscall *cEngine_ReceiveEvent)(cEngine*, cEvent*);
	void* cEngine_Free;
};

// .?AVcFont@
struct AVcFont //sizeof=0x3C
{
	void* sub_64B620;
	void* fncTexture_DrawNumberSigned;
	void* fncTexture_DrawNumberUnsigned;
	void* __purecall1;
	void* __purecall2;
	void* __purecall3;
	void* __purecall4;
	void* __purecall5;
	void* __purecall6;
	void* __purecall7;
	void* __purecall8;
	void* __purecall9;
	void* __purecall10;
	void* fncTexture_648FA0;
	void* __nullsub;
};

// .?AVcFsFont@: .?AVcFont@
struct AVcFontFS
{
	void* sub_64A640;
	int (__thiscall *fncTexture_DrawNumberSigned)(FontFS* pTex, IDirect3DDevice7** device, cRectangle* pRect, int nNumber, DWORD dwColor, int nFlag);
	int (__thiscall *fncTexture_DrawNumberUnsigned)(FontFS* pTex, IDirect3DDevice7** device, cRectangle* pRect, DWORD dwNumber, DWORD dwColor, int nFlag);
	void* fncTexture_649970;
	void* fncTexture_649870;
	void* fncTexture_6497E0;
	void* fncTexture_6499B0;
	int (__thiscall *fncFontFS_DrawTextA)(FontFS *pTex, IDirect3DDevice7** device, cRectangle* pRect, LPCSTR aText, DWORD dwColor, int nFlag);
	void* fncTexture_649AA0;
	void* fncTexture_64B640;
	void* fncTexture_64B650;
	void* sub_649CC0;
	void* fncTexture_649C50;
	void* fncTexture_648FA0;
	void* nullsub_19;
};

// .?AVcFontTTF@: .?AVcFont@
struct AVcFontTTF
{
	void* sub_64D9A0;
	int (__thiscall *fncTexture_DrawNumberSigned)(FontTTF* pTex, IDirect3DDevice7** device, cRectangle* pRect, int nNumber, DWORD dwColor, int nFlag);
	int (__thiscall *fncTexture_DrawNumberUnsigned)(FontTTF* pTex, IDirect3DDevice7** device, cRectangle* pRect, DWORD dwNumber, DWORD dwColor, int nFlag);
	int (__thiscall *FontTEX_DrawPopUpText2)(FontTTF *pTex, IDirect3DDevice7** device, cRectangle* pRect, LPWSTR szText, DWORD dwColor, int nFlag);
	void* fncTexture_64D0A0;
	int (__thiscall *FontTEX_DrawTextA)(FontTTF *pTex, IDirect3DDevice7** device, cRectangle* pRect, LPCSTR aText, DWORD dwColor, int nFlag);
	void* fncTexture_64D1D0;
	void* fncTexture_64C1E0;
	void* fncTexture_64D600;
	void* fncTexture_64D460;
	void* fncTexture_64D490;
	void* sub_64D3A0;
	void* fncTexture_64D2C0;
	void* fncTexture_648FA0;
	void* nullsub_19;
	void* fncTexture_64D4D0;
	void* fncTexture_64D540;
	void* fncTexture_64D550;
};

// .?AVcFontTTF2@: .?AVcFont@
struct AVcFontTEX
{
	void (__thiscall *cFontTTF2_vecDelDtor)(cFontTTF2* fnt, char flags);
	int (__thiscall *cFontTTF2_DrawNumberSigned)(cFontTTF2* fnt, IDirect3DDevice7** device, cRectangle* pRect, int nNumber, DWORD dwColor, int nFlag);
	int (__thiscall *cFontTTF2_DrawNumberUnsigned)(cFontTTF2* fnt, IDirect3DDevice7** device, cRectangle* pRect, DWORD dwNumber, DWORD dwColor, int nFlag);
	int (__thiscall *cFontTTF2_DrawTextSTRW2)(cFontTTF2* fnt, IDirect3DDevice7** device, cRectangle* rect, STR_W* str, DWORD color, int flags);
	int (__thiscall *cFontTTF2_DrawTextSTRW)(cFontTTF2* fnt, IDirect3DDevice7** device, cRectangle* rect, STR_W str, DWORD color, int flags);
	int (__thiscall *cFontTTF2_DrawTextSTRA)(cFontTTF2* fnt, IDirect3DDevice7** device, cRectangle* rect, STR_A str, DWORD color, int flags);
	int (__thiscall *cFontTTF2_DrawTextW)(cFontTTF2* fnt, IDirect3DDevice7** device, cRectangle* rect, LPWSTR str, DWORD color, int flags);
	int (__thiscall *cFontTTF2_DrawTextA)(cFontTTF2* fnt, IDirect3DDevice7** device, cRectangle* rect, LPCSTR str, DWORD color, int flags);
	void (__thiscall *cFontTTF2_DrawRectangle)(cFontTTF2* fnt, IDirect3DDevice7** device, cRectangle* pRect, int);
	WORD (__thiscall *cFontTTF2_GetMaxCharWidth)(cFontTTF2* fnt, char n);
	int (__thiscall *cFontTTF2_GetHeight)(cFontTTF2* fntx, int);
	int (__thiscall *cFontTTF2_GetTextWidthW)(cFontTTF2* fnt, LPWSTR);
	int (__thiscall *cFontTTF2_GetTextWidthA)(cFontTTF2* fnt, LPCSTR);
	int (__thiscall *cFontTTF2_QueryStatus)(cFontTTF2* fnt, eFontStatus fstat, int paramI, float paramF);
	void* cFontTTF2_Reinit;
	WORD (__thiscall *cFontTTF2_GetFontHeight)(cFontTTF2* fnt);
	int (__thiscall *cFontTTF2_SetNewLineHeight)(cFontTTF2* fnt, LONG);
	int (__thiscall *cFontTTF2_SetSpaceWidth)(cFontTTF2* fnt, LONG);
};



/////////////////////////////////////////////////////////////////////////////////
// Events
/////////////////////////////////////////////////////////////////////////////////
// .?AVcEvent@
struct AVcEvent
{
	void (__thiscall *cEvent_Free)(cEvent* pEvt, BYTE isHeapFree);
	int (*cEvent_GetType)();
	int (*cEvent_GetSubType)();
	cEvent* (__thiscall *cEvent_Dup)(cEvent* pEvt);
	int (__thiscall *cEvent_Save)(cEvent* pEvt, FILE* hFile);
	int (__thiscall *cEvent_Load)(cEvent* pEvt, FILE* hFile);
};
// 0.0, .?AVcEvent_idle@: .?AVcEvent@
struct AVcEventIdle
{
	void (__thiscall *cEventIdle_Free)(cEventIdle* pEvt, BYTE isHeapFree);
	int (*cEventIdle_GetType)();
	int (*cEventIdle_GetSubType)();
	cEventIdle* (__thiscall *cEventIdle_Dup)(cEventIdle* pEvt);
	int (__thiscall *cEventIdle_Save)(cEventIdle* pEvt, FILE* hFile);
	int (__thiscall *cEventIdle_Load)(cEventIdle* pEvt, FILE* hFile);
};
// 1.0, .?AVcEvent_mouseMove@: .?AVcEvent@
struct AVcEventMouseMove
{
	void (__thiscall *cEventMouseMove_Free)(cEventMouseMove* pEvt, BYTE isHeapFree);
	int (*cEventMouseMove_GetType)();
	int (*cEventMouseMove_GetSubType)();
	cEventMouseMove* (__thiscall *cEventMouseMove_Dup)(cEventMouseMove* pEvt);
	int (__thiscall *cEventMouseMove_Save)(cEventMouseMove* pEvt, FILE* hFile);
	int (__thiscall *cEventMouseMove_Load)(cEventMouseMove* pEvt, FILE* hFile);
};
// 2.0, .?AVcEvent_mouseButton_down@: .?AVcEvent_mouseButton@, .?AVcEvent@
struct AVcEventMouseButtonDown
{
	void (__thiscall *cEventMouseButtonDown_Free)(cEventMouseButtonDown* pEvt, BYTE isHeapFree);
	int (*cEventMouseButtonDown_GetType)();
	int (*cEventMouseButtonDown_GetSubType)();
	cEventMouseButtonDown* (__thiscall *cEventMouseButtonDown_Dup)(cEventMouseButtonDown* pEvt);
	int (__thiscall *cEventMouseButtonDown_Save)(cEventMouseButtonDown* pEvt, FILE* hFile);
	int (__thiscall *cEventMouseButtonDown_Load)(cEventMouseButtonDown* pEvt, FILE* hFile);
};
// 3.0, .?AVcEvent_mouseButton_down@: .?AVcEvent_mouseButton@, .?AVcEvent@
struct AVcEventMouseButtonUp
{
	void (__thiscall *cEventMouseButtonUp_Free)(cEventMouseButtonUp* pEvt, BYTE isHeapFree);
	int (*cEventMouseButtonUp_GetType)();
	int (*cEventMouseButtonUp_GetSubType)();
	cEventMouseButtonUp* (__thiscall *cEventMouseButtonUp_Dup)(cEventMouseButtonUp* pEvt);
	int (__thiscall *cEventMouseButtonUp_Save)(cEventMouseButtonUp* pEvt, FILE* hFile);
	int (__thiscall *cEventMouseButtonUp_Load)(cEventMouseButtonUp* pEvt, FILE* hFile);
};
// 4.0, .?AVcEvent_key@: .?AVcEvent@
struct AVcEventKey
{
	void (__thiscall *cEventKey_Free)(cEventKey* pEvt, BYTE isHeapFree);
	int (*cEventKey_GetType)();
	int (*cEventKey_GetSubType)();
	cEventKey* (__thiscall *cEventKey_Dup)(cEventKey* pEvt);
	int (__thiscall *cEventKey_Save)(cEventKey* pEvt, FILE* hFile);
	int (__thiscall *cEventKey_Load)(cEventKey* pEvt, FILE* hFile);
};
// 5.16, .?AVcEventUI2@: .?AVcEvent@
struct AVcEventUI2
{
	void (__thiscall *cEventUI2_Free)(cEventUI2*, BYTE isHeapFree);
	int (*cEventUI2_GetType)();
	int (*cEventUI2_GetSubType)();
	cEventUI2* (__thiscall *cEventUI2_Dup)(cEventUI2*);
	int (__thiscall *cEventUI2_Save)(cEventUI2*, FILE*);
	int (__thiscall *cEventUI2_Load)(cEventUI2*, FILE*);
};
// 5.17, .?AVcEventUI_string@: .?AVcEventUI2@, .?AVcEvent@
struct AVcEventUI_String
{
	void (__thiscall *cEventUI_String_Free)(cEventUI_String* pEvt, BYTE isHeapFree);
	int (*cEventUI_String_GetType)();
	int (*cEventUI_String_GetSubType)();
	cEventUI_String* (__thiscall *cEventUI_String_Dup)(cEventUI_String* pEvt);
	int (__thiscall *cEventUI_String_Save)(cEventUI_String* pEvt, FILE* hFile);
	int (__thiscall *cEventUI_String_Load)(cEventUI_String* pEvt, FILE* hFile);
	cEventUI_String* (__thiscall *cEventUI_String_Dup2)(cEventUI_String* pEvt);
};
// 6.32, .?AVcEvent_engine@: .?AVcEvent@
struct AVcEventEngine
{
	void (__thiscall *cEventEngine_Free)(cEventEngine* pEvt, BYTE isHeapFree);
	int (*cEventEngine_GetType)();
	int (*cEventEngine_GetSubType)();
	cEventEngine* (__thiscall *cEventEngine_Dup)(cEventEngine* pEvt);
	int (__thiscall *cEventEngine_Save)(cEventEngine* pEvt, FILE* hFile);
	int (__thiscall *cEventEngine_Load)(cEventEngine* pEvt, FILE* hFile);
};
// 6.33, .?AVcEventTrigger: .?AVcEvent@
struct AVcEventTrigger
{
	void (__thiscall *cEventTrigger_Free)(cEventTrigger* pEvt, BYTE isHeapFree);
	int (*cEventTrigger_GetType)();
	int (*cEventTrigger_GetSubType)();
	cEventTrigger* (__thiscall *cEventTrigger_Dup)(cEventTrigger* pEvt);
	int (__thiscall *cEventTrigger_Save)(cEventTrigger* pEvt, FILE* hFile);
	int (__thiscall *cEventTrigger_Load)(cEventTrigger* pEvt, FILE* hFile);
};
// 6.34, .?AVcEventObject: .?AVcEvent@
struct AVcEventObject
{
	void (__thiscall *cEventObject_Free)(cEventObject* pEvt, BYTE isHeapFree);
	int (*cEventObject_GetType)();
	int (*cEventObject_GetSubType)();
	cEventObject* (__thiscall *cEventObject_Dup)(cEventObject* pEvt);
	int (__thiscall *cEventObject_Save)(cEventObject* pEvt, FILE* hFile);
	int (__thiscall *cEventObject_Load)(cEventObject* pEvt, FILE* hFile);
};
// 6.36, .?AVcEventWeather: .?AVcEvent@
struct AVcEventWeather
{
	void (__thiscall *cEventWeather_Free)(cEventWeather* pEvt, BYTE isHeapFree);
	int (*cEventWeather_GetType)();
	int (*cEventWeather_GetSubType)();
	cEventWeather* (__thiscall *cEventWeather_Dup)(cEventWeather* pEvt);
	int (__thiscall *cEventWeather_Save)(cEventWeather* pEvt, FILE* hFile);
	int (__thiscall *cEventWeather_Load)(cEventWeather* pEvt, FILE* hFile);
};
// 6.37, .?AVcEventConsole@: .?AVcEvent@
struct AVcEventConsole
{
	void (__thiscall *cEventConsole_Free)(cEventConsole* pEvt, BYTE isHeapFree);
	int (*cEventConsole_GetType)();
	int (*cEventConsole_GetSubType)();
	cEventConsole (__thiscall *cEventConsole_Dup)(cEventConsole* pEvt);
	int (__thiscall *cEventConsole_Save)(cEventConsole* pEvt, FILE* hFile);
	int (__thiscall *cEventConsole_Load)(cEventConsole* pEvt, FILE* hFile);
};
// 7.35, .?AVcEvent_creature@: .?AVcEvent@
struct AVcEventCreature
{
	void (__thiscall *cEventCreature_Free)(cEventCreature* pEvt, BYTE isHeapFree);
	int (*cEventCreature_GetType)();
	int (*cEventCreature_GetSubType)();
	cEventCreature* (__thiscall *cEventCreature_Dup)(cEventCreature* pEvt);
	int (__thiscall *cEventCreature_Save)(cEventCreature* pEvt, FILE* hFile);
	int (__thiscall *cEventCreature_Load)(cEventCreature* pEvt, FILE* hFile);
};
// 8.0, .?AVcEventFX@: .?AVcEvent@
struct AVcEventFX
{
	void (__thiscall *cEventFX_Free)(cEventFX* pEvt, BYTE isHeapFree);
	int (*cEventFX_GetType)();
	int (*cEventFX_GetSubType)();
	cEventFX* (__thiscall *cEventFX_Dup)(cEventFX* pEvt);
	int (__thiscall *cEventFX_Save)(cEventFX* pEvt, FILE* hFile);
	int (__thiscall *cEventFX_Load)(cEventFX* pEvt, FILE* hFile);
};
// 9.0, .?AVcEventArrow@: .?AVcEvent@
struct AVcEventArrow
{
	void (__thiscall *cEventArrow_Free)(cEventArrow* pEvt, BYTE isHeapFree);
	int (*cEventArrow_GetType)();
	int (*cEventArrow_GetSubType)();
	cEventArrow* (__thiscall *cEventArrow_Dup)(cEventArrow* pEvt);
	int (__thiscall *cEventArrow_Save)(cEventFX* pEvt, FILE* hFile);
	int (__thiscall *cEventArrow_Load)(cEventFX* pEvt, FILE* hFile);
};
// 10.0, .?AVcEventNetwork@: .?AVcEvent@
struct AVcEventNetwork
{
	void (__thiscall *cEventNetwork_Free)(cEventNetwork* pEvt, BYTE isHeapFree);
	int (*cEventNetwork_GetType)();
	int (*cEventNetwork_GetSubType)();
	cEventNetwork* (__thiscall *cEventNetwork_Dup)(cEventNetwork* pEvt);
	int (__thiscall *cEventNetwork_Save)(cEventFX* pEvt, FILE* hFile);
	int (__thiscall *cEventNetwork_Load)(cEventFX* pEvt, FILE* hFile);
};
// 11.38, .?AVcEventProfile@: .?AVcEvent@
struct AVcEventProfile
{
	void (__thiscall *cEventProfile_Free)(cEventProfile* pEvt, BYTE isHeapFree);
	int (*cEventProfile_GetType)();
	int (*cEventProfile_GetSubType)();
	cEventProfile* (__thiscall *cEventProfile_Dup)(cEventProfile* pEvt);
	int (__thiscall *cEventProfile_Save)(cEventFX* pEvt, FILE* hFile);
	int (__thiscall *cEventProfile_Load)(cEventFX* pEvt, FILE* hFile);
};
// 12.0, .?AVcEventIME@: .?AVcEvent@
struct AVcEventIME
{
	void (__thiscall *cEventIME_Free)(cEventIME* pEvt, BYTE isHeapFree);
	int (*cEventIME_GetType)();
	int (*cEventIME_GetSubType)();
	cEventIME* (__thiscall *cEventIME_Dup)(cEventIME* pEvt);
	int (__thiscall *cEventIME_Save)(cEventIME* pEvt, FILE* hFile);
	int (__thiscall *cEventIME_Load)(cEventIME* pEvt, FILE* hFile);
};



// .?AVcTimerListener@
// cTimerListener::`vftable'
struct AVcTimerListener
{
	void* (__thiscall *Free)(cTimerListener*, DWORD);
	void (__thiscall *AdvanceTime)(cTimerListener*, float);
	void (__thiscall *OnActivate)(cTimerListener*, char);
};
// .?AVcObject@, .?AVcTimerListener@
// cObject::`vftable'
struct AVcObject
{
	void* (__thiscall *Free)(cObject*, DWORD);
	void (__thiscall *AdvanceTime)(cObject*, float);
	void (__thiscall *OnActivate)(cObject*, char);
	void* sub03;
	void* sub04;
	void* Render;
	void (__thiscall *ReceiveEvent)(cObject*, cEvent*);
	int (__thiscall *Save)(cObject*, cFile*, char, int);
	int (__thiscall *CreatePacket)(cObject*, cFile*, int, DWORD);
	DWORD (__thiscall *GetStatus)(cObject*, eObjectCmd, int);
};
// .?AVcObject@, .?AVcObject@, .?AVcTimerListener@
// cObject3D::`vftable'
struct AVcObject3D
{
	void* (__thiscall *Free)(cObject3D*, DWORD);
	void (__thiscall *AdvanceTime)(cObject3D*, float);
	void (__thiscall *OnActivate)(cObject3D*, char);
	void* sub03;
	void* sub04;
	void (__thiscall *Render)(cObject3D* pCreat, IDirect3DDevice7** device, int);
	void (__thiscall *ReceiveEvent)(cObject3D*, cEvent*);
	int (__thiscall *Save)(cObject3D*, cFile*, char, int);
	int (__thiscall *CreatePacket)(cObject3D*, cFile*, int, DWORD);
	DWORD (__thiscall *GetStatus)(cObject3D*, eObjectCmd, int);
	char (__thiscall *GrnSequenceLoad)(cObject3D*, char);
	char (__thiscall *AnimationCreate)(cObject3D*, eMotionType, float, float);
};

// .?AVcItemBase@: .?AVcObject3D@, .?AVcObject@, .?AVcObject@, .?AVcTimerListener@
// cItemBase::`vftable'
struct AVcItemBase
{
	void* (__thiscall *Free)(cItemBase*, DWORD);
	void (__thiscall *AdvanceTime)(cItemBase*, float);
	void (__thiscall *OnActivate)(cItemBase*, char);
	void* sub03;
	void* sub04;
	void (__thiscall *Render)(cItemBase* pCreat, IDirect3DDevice7** device, int);
	void (__thiscall *ReceiveEvent)(cItemBase*, cEvent*);
	int (__thiscall *Save)(cItemBase*, cFile*, char, int);
	int (__thiscall *CreatePacket)(cItemBase*, cFile*, int, DWORD);
	DWORD (__thiscall *GetStatus)(cItemBase*, eObjectCmd, int);
	char (__thiscall *GrnSequenceLoad)(cItemBase*, char);
	char (__thiscall *AnimationCreate)(cItemBase*, eMotionType, float, float);

	void (__thiscall *ToggleVisuals)(cItemBase*, bool, cWorldPosition*);
	void (__thiscall *ForceVisuals)(cItemBase*, cWorldPosition*, DWORD, DWORD);
	char (__thiscall *CanUse)(cItemBase*, eItemType);
	bool (__thiscall *cItemBase_5C9300)(cItemBase*, WORD, WORD);
	void (__stdcall *GetDescriptionX)(cItemBase*, sWeaponInfo_vector*);
	void (__thiscall *GetDescription)(cItemBase*, STR_W*, sWeaponInfo*, DWORD*, int);
};
// .?AVcArmor3D@: .?AVcItemBase@, .?AVcObject3D@, .?AVcObject@, .?AVcObject@, .?AVcTimerListener@
// cArmor3D::`vftable'
struct AVcArmor3D
{
	void* (__thiscall *Free)(cArmor3D*, DWORD);
	void (__thiscall *AdvanceTime)(cArmor3D*, float);
	void (__thiscall *OnActivate)(cArmor3D*, char);
	void* sub03;
	void* sub04;
	void (__thiscall *Render)(cArmor3D* pCreat, IDirect3DDevice7** device, int);
	void (__thiscall *ReceiveEvent)(cArmor3D*, cEvent*);
	int (__thiscall *Save)(cArmor3D*, cFile*, char, int);
	int (__thiscall *CreatePacket)(cArmor3D*, cFile*, int, DWORD);
	DWORD (__thiscall *GetStatus)(cArmor3D*, eObjectCmd, int);
	char (__thiscall *GrnSequenceLoad)(cArmor3D*, char);
	char (__thiscall *AnimationCreate)(cArmor3D*, eMotionType, float, float);

	void (__thiscall *ToggleVisuals)(cArmor3D*, bool, cWorldPosition*);
	void (__thiscall *ForceVisuals)(cArmor3D*, cWorldPosition*, DWORD, DWORD);
	char (__thiscall *CanUse)(cArmor3D*, eItemType);
	bool (__thiscall *cItemBase_5C9300)(cArmor3D*, WORD, WORD);
	void (__stdcall *GetDescriptionX)(cArmor3D*, sWeaponInfo_vector*);
	void (__thiscall *GetDescription)(cArmor3D*, STR_W*, sWeaponInfo*, DWORD*, int);
};



// .?AVcCreature@: .?AVcObject3D@, .?AVcObject@, .?AVcObject@, .?AVcTimerListener@
// 
struct AVcCreature
{
	void* (__thiscall *Free)(cCreature*, DWORD);
	void (__thiscall *AdvanceTime)(cCreature*, float);
	void (__thiscall *OnActivate)(cCreature*, char);
	void* sub03;
	void* sub04;
	void (__thiscall *Render)(cCreature* pCreat, IDirect3DDevice7** device, int);
	void (__thiscall *ReceiveEvent)(cCreature*, cEvent*);
	int (__thiscall *Save)(cCreature*, cFile*, char, int);
	int (__thiscall *CreatePacket)(cCreature*, cFile*, int, DWORD);
	DWORD (__fastcall *GetStatus)(cCreature*, int, eObjectCmd, int);
	char (__thiscall *GrnSequenceLoad)(cCreature*, char);
	char (__thiscall *AnimationCreate)(cCreature*, eMotionType, float, float);

	void (__thiscall *ToggleVisuals)(cCreature*, bool, cWorldPosition*);
	void (__thiscall *ForceVisuals)(cCreature*, cWorldPosition*, DWORD, DWORD);
	char (__thiscall *CanUse)(cCreature*, eItemType);
	bool (__thiscall *cItemBase_5C9300)(cCreature*, WORD, WORD);
	void (__stdcall *GetDescriptionX)(cCreature*, sWeaponInfo_vector*);
	void (__fastcall *GetDescription)(cCreature*, int, STR_W*, sWeaponInfo*, DWORD*, int);
};



// .?AVCommandUV1@cUI_Control@: .?AVParamCommand
struct AVCommandUV1
{
	void* fns_733000;
	void* fns_733130;
};



// .?AVStringInterface@
struct AVcUI_StringInterface
{
	void* fnsStringInterface_Free;
	void* fnsStringInterface_6A5A10;
	void* fnsStringInterface_6A5B60;
	void* fnsStringInterface_6A5C80;
};

// .?AVcUI_Control2@: .?AVStringInterface@
struct AVcUI_Control
{
	void* (__thiscall *cUI_Control_vecDelDtor)(cUI_Control*, DWORD flags);
	void* fnsStringInterface_6A5A10;
	void* fnsStringInterface_6A5B60;
	void* fnsStringInterface_6A5C80;
	char (__thiscall *cUI_Control_ReceiveEvent)(cUI_Control*, cEventUI2*);
	void (__thiscall *cUI_Control_Render)(cUI_Control*, IDirect3DDevice7**);
	int (__thiscall *cUI_Control_IsInside2)(cUI_Control*, cRectangle*);
	bool (__thiscall *cUI_Control_IsInside)(cUI_Control*, int, int);
	void* cUI_Control_StrUI;
	void (__thiscall *cUI_Control_OnShow)(cUI_Control*, char);
	void* cUI_Control_7324B0;
	int (__thiscall *cUI_Control_TabDestroy)(cUI_Control*, cUI_Control*);
};
// ; .?AVcUI_Static2@: .?AVcUI_Control2@, .?AVStringInterface@
struct AVcUI_Static
{
	void* (__thiscall *cUI_Static_vecDelDtor)(cUI_Static*, DWORD flags);
	void* fnsStringInterface_6A5A10;
	void* fnsStringInterface_6A5B60;
	void* fnsStringInterface_6A5C80;
	char (__thiscall *cUI_Static_ReceiveEvent)(cUI_Static*, cEventUI2*);
	void (__thiscall *cUI_Static_Render)(cUI_Static*, IDirect3DDevice7**);
	int (__thiscall *cUI_Control_IsInside2)(cUI_Control*, cRectangle*);
	bool (__thiscall *cUI_Control_IsInside)(cUI_Control*, int, int);
	void* cUI_Static_StrUI;
	void (__thiscall *cUI_Control_OnShow)(cUI_Control*, char);
	void* cUI_Static_753410;
	int (__thiscall *cUI_Control_TabDestroy)(cUI_Control*, cUI_Control*);
};
// ; .?AVcUI_Scrollbar@: .?AVcUI_Control2@, .?AVStringInterface@
struct AVcUI_Scrollbar
{
	void* (__thiscall *cUI_Scrollbar_vecDelDtor)(cUI_Scrollbar*, DWORD flags);
	void* fnsStringInterface_6A5A10;
	void* fnsStringInterface_6A5B60;
	void* fnsStringInterface_6A5C80;
	char (__thiscall *cUI_Scrollbar_ReceiveEvent)(cUI_Scrollbar*, cEventUI2*);
	void (__thiscall *cUI_Scrollbar_Render)(cUI_Scrollbar*, IDirect3DDevice7**);
	int (__thiscall *cUI_Control_IsInside2)(cUI_Control*, cRectangle*);
	bool (__thiscall *cUI_Control_IsInside)(cUI_Control*, int, int);
	void* cUI_Scrollbar_StrUI;
	void (__thiscall *cUI_Control_OnShow)(cUI_Control*, char);
	void* cUI_Scrollbar_7520E0;
	int (__thiscall *cUI_Control_TabDestroy)(cUI_Control*, cUI_Control*);
};
// ; .?AVcUI_Listbox@: .?AVcUI_Control2@, .?AVStringInterface@
struct AVcUI_Listbox
{
	void* (__thiscall *cUI_Listbox_vecDelDtor)(cUI_Listbox*, DWORD flags);
	void* fnsStringInterface_6A5A10;
	void* fnsStringInterface_6A5B60;
	void* fnsStringInterface_6A5C80;
	char (__thiscall *cUI_Listbox_ReceiveEvent)(cUI_Listbox*, cEventUI2*);
	void (__thiscall *cUI_Listbox_Render)(cUI_Listbox*, IDirect3DDevice7**);
	int (__thiscall *cUI_Control_IsInside2)(cUI_Control*, cRectangle*);
	bool (__thiscall *cUI_Control_IsInside)(cUI_Control*, int, int);
	void* cUI_Listbox_StrUI;
	void (__thiscall *cUI_Control_OnShow)(cUI_Control*, char);
	void* cUI_Listbox_7520E0;
	int (__thiscall *cUI_Control_TabDestroy)(cUI_Control*, cUI_Control*);
};




// .?AVcUI_Window2@: .?AVcUI_Control2@, .?AVStringInterface@
struct AVcUI_Window
{
	void* fnsUI_Window_Free;
	void* fnsStringInterface_6A5A10;
	void* fnsStringInterface_6A5B60;
	void* fnsStringInterface_6A5C80;
	char (__thiscall *cUI_Window_ReceiveEvent)(UI_Window*, cEventUI2*);
	void (__thiscall *cUI_Window_Render)(UI_Window*, IDirect3DDevice7**);
	int (__thiscall *cUI_Control_IsInside2)(cUI_Control*, cRectangle*);
	bool (__thiscall *cUI_Control_IsInside)(cUI_Control*, int, int);
	void* cUI_Window_6A5D40;
	void (__thiscall *cUI_Window_OnShow)(UI_Window*, char);
	void* cUI_Control_7324B0;
	void (__thiscall *cUI_Window_TabDestroy)(UI_Window*, cUI_Control*);
	void (__thiscall *cUI_Window_AdvanceTime)(UI_Window*, float);
	char (__thiscall *cUI_Window_OnEscape)(UI_Window*);
	char (__thiscall *cUI_Window_OnEnter)(UI_Window*);
	void* cUI_Window_GuiconfigSave;
	void* cUI_Window_GuiconfigLoad;
};




// .?AVcUI_StaticText64@: .?AVcUI_Control2@, .?AVStringInterface@
struct AVcUI_StaticText64
{
	void* sub_7550C0;
	void* sub_6A5A10;
	void* sub_6A5B60;
	void* sub_6A5C80;
	char (__thiscall *fncUI_StaticText64_ReceiveEvent)(UI_StaticText64* pTxt64, cEventMouseButtonDown *pEvt);
	void (__thiscall *fncUI_StaticText64_Draw)(UI_StaticText64* pTxt64, IDirect3DDevice7** device);
	void* sub_7320E0;
	void* sub_732050;
	void* sub_754FB0;
	void* nullsub_68;
	void* sub_7538E0;
	void* sub_732460;
};


// .?AVcUI_Button2@: .?AVcUI_Control2@, .?AVStringInterface@
struct AVcUI_Button2
{
	void* UI_Button_Free;
	void* StringInterface_6A5A10;
	void* StringInterface_6A5B60;
	void* StringInterface_6A5C80;
	void* UI_Button_ReceiveEvent;
	void (__thiscall *cUI_Button_Render)(cUI_Button* pBtn, IDirect3DDevice7** device);
	void* UI_Control2_7320E0;
	void* UI_Control2_732050;
	void* UI_Button_72D450;
	void* UI_Control2_7323C0;
	void* UI_Button_72A640;
	void* UI_Control2_732460;
};

// ?AVcUI_NetGranny@: .?AVcUI_Window2@: .?AVcUI_Control2@, .?AVStringInterface@
struct AVcUI_NetGranny
{
	void* UI_NetGranny_Free;
	void* StringInterface_6A5A10;
	void* StringInterface_6A5B60;
	void* StringInterface_6A5C80;
	void* UI_NetGranny_6F3CA0;
	void* UI_NetGranny_6F2320;
	void* UI_Control_7320E0;
	void* UI_Control_732050;
	void* UI_Window_6A5D40;
	void* UI_NetGranny_Event_6F3C70;
	void* UI_Control_7324B0;
	void* UI_Window_7247A0;
	void* UI_NetGranny_6F1500;
	void* UI_Window_724650;
	void* UI_Window_724640;
	void* UI_Window_727B30;
	void* UI_Window_727B40;
	void* UI_NetGranny_Draw;
};




struct cParticleSystemVtbl
{
	void (__thiscall *vecDelDtor)(cParticleSystem* pPsm, char isHeapFree);
	int (__thiscall *Render)(cParticleSystem* pPsm, IDirect3DDevice7** device, D3DMATRIX invViewMatrix);
	void (__thiscall *AdvanceTime)(cParticleSystem* pPsm, float t);
	int (__thiscall *IsAlive)(cParticleSystem* pPsm);
	int (__thiscall *Start)(cParticleSystem* pPsm, cEventFX* event);
	int (__thiscall *Save)(cParticleSystem* pPsm, FileRam* pFram, int isSave);
	int (__thiscall *CreatePacket)(cParticleSystem* pPsm, FileRam *pFram, char save, int event);
};

////////////////////////////////////////////////////////////////////////////
#pragma pack()

