
#include "../../../defs.h"
#include "../../mod_defs.h"
#include "../../mod_functions.h"
#include "../../mod_variables.h"
////////////////////////////////////////////////////////////////////////////


EHighResolutionTimer hrt;
int frames = 0;
double fps = 0.0;
//------------------------------------------------------------------------------------------------------- OnEngineThread_EndScene
// in cEngine::RenderThread, on dxDriver7::EndScene
//----------------------------------------------------------------------
void __stdcall OnEngineThread_EndScene(dxDriver7* pDirect)
{

	cEngine* eng = *g_Engine;
	if(!eng) return;
	cWorldView2* wview = WorldView2_GetView();
	if(!wview) return;
	cWorld* wld = eng->pWorld;

	//ToDo


	//--------------------------------------------
	dxDriver7_EndScene(pDirect);
}


//----------------------------------------------------------------------
DWORD UI_Manager_GetMainMenuWindowID()
{
	cUI_Manager* uim = *g_UI_Manager;
	if(uim)
	{
		cUI_Manager_MainMenu* mm = &uim->mainmenu;
		if(mm)
		{
			BYTE ch = 0;
			if(mm->ui_mainmenu) if(mm->ui_mainmenu->wnd.base.flags & 1)
				return 0x00000011 | (mm->ui_mainmenu->state << 8);
			if(mm->ui_character2) if(mm->ui_character2->wnd.base.flags & 1)
			{
				ch = mm->ui_character2->modelNr + 1;
				return 0x00000021 | ((*g_nGameType) << 12) | (mm->ui_character2->state << 16) | (ch << 20);
			}
			if(mm->ui_wnd_options2) if(mm->ui_wnd_options2->wnd.base.flags & 1)
				return 0x00000031;
			if(mm->ui_wnd_savegame2) if(mm->ui_wnd_savegame2->wnd.base.flags & 1)
				return 0x00000041;
			if(mm->ui_wnd_network) if(mm->ui_wnd_network->wnd.base.flags & 1)
			{
				cUI_Network* tmp = mm->ui_wnd_network;
				ch = tmp->ui_character->modelNr + 1;
				return 0x00000051 | (tmp->state << 8) | (tmp->mode << 12) | (tmp->ui_character->state << 16) | (ch << 20);
			}
		}
	}
	return 0;
}
//----------------------------------------------------------------------
DWORD UI_Manager_GetGameWindowID()
{
	cUI_Manager* uim = *g_UI_Manager;
	if(uim)
	{
		cUI_Manager_Taskbar* tb = &uim->taskbar;
		if(tb)
		{
			BYTE ch = 0;
			if(tb->ui_character) if(tb->ui_character->wnd.base.flags & 1)
			{
				ch = tb->ui_character->modelNr + 1;
				return 0x00000022 | ((*g_nGameType) << 12) | (tb->ui_character->state << 16) | (ch << 20);
			}
			if(tb->ui_wnd_options) if(tb->ui_wnd_options->wnd.base.flags & 1)
				return 0x00000032;
			if(tb->ui_wnd_savegame) if(tb->ui_wnd_savegame->wnd.base.flags & 1)
				return 0x00000042 | (tb->ui_wnd_savegame->inSaveMode << 12);
			return 0x00000012;
		}
	}
	return 0;
}
//----------------------------------------------------------------------
BOOL UI_Manager_IsConsole()
{
	cUI_Manager* uim = *g_UI_Manager;
	if(uim)
	{
		cUI_Manager_Taskbar* tb = &uim->taskbar;
		if(tb)
		{
			if(tb->ui_wnd_console) if(tb->ui_wnd_console->wnd.base.flags & 1) return TRUE;
		}
	}
	return FALSE;
}


//----------------------------------------------------------------------------------------------------- OnManagerThread_EndScene
//
//----------------------------------------------------------------------
void __fastcall OnManagerThread_EndScene(dxDriver7* pDirect)
{

	//ToDo

	//--------------------------------------------
	dxDriver7_EndScene(pDirect);
}

//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
void __stdcall DrawInfo2(cEngine* pEng, IDirect3DDevice7** device, char a4)
{
	cEngine_DrawCursor(pEng, device, a4);
	//----------------------------------------------------------------------

	//ToDo
}
//----------------------------------------------------------------------
// 0060ECB7    call fncEngine_DrawCursor
//----------------------------------------------------------------------
DWORD dw7346203;
void __NAKED DrawInfo2_STUB()
{
	__asm
	{
		pop dw7346203
		push esi
		call DrawInfo2
		jmp dw7346203
	}
}



//----------------------------------------------------------------------
NAKED_FUNC(dw8373645, OnManagerThread_EndScene_STUB)
{
	push esi
	push edi
	call OnManagerThread_EndScene
	pop edi
	pop esi
	END_FUNC(dw8373645)
}
//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
NAKED_FUNC(dw28455, OnEngineThread_EndScene_STUB)
{
	push ecx
	call OnEngineThread_EndScene
	END_FUNC(dw28455)
}
//----------------------------------------------------------------------
//






//------------------------------------------------------------------------------------------------------------- Install_SysInfo
//
//----------------------------------------------------------------------
void Install_SysInfo()
{
	call_ref(R8(Sacred, 00756F35), (DWORD)OnManagerThread_EndScene_STUB);
	call_ref(R8(Sacred, 0060ED0E), (DWORD)OnEngineThread_EndScene_STUB);


}



