
#include "../../../defs.h"
#include "../../mod_defs.h"
#include "../../mod_functions.h"
#include "../../mod_variables.h"
////////////////////////////////////////////////////////////////////////////


//---------------------------------------------------------------------------------------------------------------------------- OnDrawUI_TASKBAR
int t = 0, xx = 0;
DWORD dwColor = 0xFF00FF00;
BOOL isOnce = TRUE;

void __stdcall OnDrawUI_TASKBAR(cUI_Taskbar2* pTask, char force)
{
	//ToDo

	//----------------------------------------------------------------------
	cUI_Taskbar_RefreshSlotGfx(pTask, force);
}

void __stdcall OnDrawAfterUI_TASKBAR(cUI_Taskbar2* pTask, IDirect3DDevice7** device)
{
	//---------------------------------------------- Hero name patch
	if(!g_isLoadGame)
	{
		cCreature* pCreat = cObjectManager_GetHero(*g_ObjectManager);
		if(pCreat)
		{
			LPWSTR str = Creature_GetStringW(pCreat);
			swprintf(g_UserName, str);
		}
		g_isLoadGame = FALSE;
	}

	//ToDo

	//----------------------------------------------------------------------
	cUI_Taskbar_RenderTooltip(pTask, device);
}



//---------------------------------------------------------------------------------------------------------------------------- OnDrawAfterUI
//
//----------------------------------------------------------------------
void __stdcall OnDrawAfterUI(cUI_Manager* pUIMng, IDirect3DDevice7** device, char onlyHelp)
{
	//ToDo

	//--------------------------------------------
	cUI_Manager_RenderTooltips(pUIMng, device, onlyHelp);
}

//---------------------------------------------------------------------------------------------------------------------------- OnDrawAfterAfterUI_STUB
//
//----------------------------------------------------------------------
cFontMgr* __stdcall OnDrawAfterAfterUI(cUI_Manager* pUIMng)
{
	//ToDo

	//--------------------------------------------
	return Fonts_Create();
}

//---------------------------------------------------------------------------------------------------------------------------- OnDrawUI1
//
//----------------------------------------------------------------------
void __stdcall OnDrawUI1(cUI_Manager* pUIMng, IDirect3DDevice7** device, char onlyHelp)
{
	g_isLoadGame = FALSE;
	PrintA(12, SCY - 22, 7, 0xFFFFFFFF, "pureHD \xA0" DLL_VERSION);

	//ToDo

	//--------------------------------------------
	cUI_Manager_RenderTooltips(pUIMng, device, onlyHelp);
}






//------------------------------------------------------------------------------------------------------- Cur In Panel
//
//----------------------------------------------------------------------
BOOL __stdcall IsCurInPanel(int x, int y)
{
	//ToDo

	return 0;
}
//----------------------------------------------------------------------
DWORD dw10083348;
DWORD loc75A7B3;
DWORD loc75A7BC;
void __NAKED IsCurInPanel_STUB()
{
	__asm
	{
		pop dw10083348
		push ebp
		push ebx
		call IsCurInPanel
		test eax, eax
		jnz short N1
		mov ecx, [esi+84h]
		test ecx, ecx
		jz short N2
		test byte ptr [ecx+10h], 1
		jmp dw10083348
N1:
		jmp loc75A7B3
N2:
		jmp loc75A7BC
	}
}




//----------------------------------------------------------------------
NAKED_FUNC(dw10037843, OnDrawAfterUI_STUB)
{
	push ecx
	call OnDrawAfterUI
	END_FUNC(dw10037843)
}
//----------------------------------------------------------------------
NAKED_FUNC(dw1777e6e, OnDrawAfterAfterUI_STUB)
{
	push ebp
	call OnDrawAfterAfterUI
	END_FUNC(dw1777e6e)
}
//----------------------------------------------------------------------
NAKED_FUNC(dw66rtgfd, OnDrawUI1_STUB)
{
	push ecx
	call OnDrawUI1
	END_FUNC(dw66rtgfd)
}
//----------------------------------------------------------------------
NAKED_FUNC(dw8630883, OnDrawUI_TASKBAR_STUB)
{
	push ecx
	call OnDrawUI_TASKBAR
	END_FUNC(dw8630883)
}
NAKED_FUNC(dw8630882, OnDrawAfterUI_TASKBAR_STUB)
{
	push ecx
	call OnDrawAfterUI_TASKBAR
	END_FUNC(dw8630882)
}


//--------------------------------------------------------------------------------------------------------- Install UI
//
//----------------------------------------------------------------------
void Install_UI()
{
	//----------------------------------------------------------------------
	call_ref(R8(Sacred, 00759230), (DWORD)OnDrawAfterUI_STUB);			// cUI_Manager::Render
	call_ref(R8(Sacred, 00759275), (DWORD)OnDrawAfterAfterUI_STUB);		// cUI_Manager::Render
	call_ref(R8(Sacred, 00758FFE), (DWORD)OnDrawUI1_STUB);				// cUI_Manager::Render
	call_ref(R8(Sacred, 006E3E41), (DWORD)OnDrawUI_TASKBAR_STUB);		// cUI_Taskbar2::Render
	call_ref(R8(Sacred, 006E3ED0), (DWORD)OnDrawAfterUI_TASKBAR_STUB);	// cUI_Taskbar2::Render

	//----------------------------------------------------------------------

	//----------------------------------------------------------------------
//	SetBytes(R8(Sacred, 007576AE), "0C 00"); // not SetCinemaMode

	//----------------------------------------------------------------------
	loc75A7B3 = R8(Sacred, 0075A7B3);
	loc75A7BC = R8(Sacred, 0075A7BC);
	call_ref(R8(Sacred, 0075A79E), (DWORD)IsCurInPanel_STUB, 3);
	//----------------------------------------------------------------------

}









