#pragma once

#include <windows.h>
#include "mod_libraries.h"
#include "Game/gConst.h"
#include "Game/gStruct.h"
#include "../Service/ModifMemory.h"
#include "../Service/Service.h"
#include "../stdafx.h"
////////////////////////////////////////////////////////////////////////////


/*

NAKED_FUNC(dwXXXXXX, the_func_name)
{
	func_body
	END_FUNC(dwXXXXXX)
}

struct SBuffer//0xC =12
{
	char* buf;
	char* end;
	char* aft;
};

*/


//----------------------------------------------------------------------
#define FASTCALL	__fastcall 
#define STDCALL		__stdcall
//#define CDECL		__cdecl
#define USERCALL

//----------------------------------------------------------------------
#define __NAKED		__declspec(naked)
#define NAKED_FUNC(R, F)	DWORD R; void __declspec(naked) F##() { __asm { pop R } __asm
#define NAKED_STUB(A, R, F)	DWORD R; void __declspec(naked) F##() { __asm { pop A } __asm { pop R } __asm
#define END_FUNC(R)			} __asm { jmp R }

#define RANDOM(V)	((int)(rand() / (RAND_MAX + 1.0) * (V)))
#define R7(Z, G)	( g_dw##Z + 0x##G )
#define R8(Z, G)	( g_dw##Z + 0x##G - g_dw##Z##_Base )
#define R9(Z, G)	( g_dw##Z + (G) - g_dw##Z##_Base )
#define V2(R, V)	__asm { mov R, V } __asm { mov R, [R] }
#define V3(V, R)	__asm { mov R, V } __asm { mov [R], R }



//----------------------------------------------------------------------
extern HANDLE g_hThread;
extern HWND g_hWnd;
extern HWND g_hWndD2;
extern cCreature* g_pCurCreat;
extern cCreature* g_pCreatInCursor;
extern DDSURFACEDESC2 g_Surface;

//----------------------------------------------------------------------
extern int SCX;
extern int SCY;
extern int SCX2;
extern int SCY2;
extern int DCX;
extern int HCX;
extern int DCY;
extern int HCY;

//----------------------------------------------------------------------
void Conv_Mouse2World(cWorldView2* wview, int x, int y, cWorldPosition* pos, BOOL isTile);
void Conv_World2Mouse(cWorldView2* pWView, cWorldPosition* pos, BOOL isTile, int* x, int* y);
void Conv_World2Over(cWorldView2* pWView, cWorldPosition* pos, BOOL isTile, int vx, int vy, int vcx, int vcy, int* x, int* y);


//----------------------------------------------------------------------
// 
//----------------------------------------------------------------------
#define Q5366563  53.66563
#define __toIso(x)	( (int)((float)x * Q5366563) )


//----------------------------------------------------------------------
typedef void (__stdcall *EVENTPROC)(cKernel*, cEvent*, int, int);
#define EVENTPARS(fn) (EVENTPROC)fn, pKer, nEvtCat, when_in_ms

#define IS_EVENT_KEY1(evt, key, ctrl)	(evt && evt->wVirtKey1 == key && evt->wControl == ctrl)
#define IS_EVENT_KEY2(evt, key, ctrl)	(evt && evt->wVirtKey2 == key && evt->wControl == ctrl)

#define IS_EVENT_KEY1_DUO(evt, key1, key2, ctrl)	(evt && (evt->wVirtKey1 == key1 || evt->wVirtKey1 == key2) && evt->wControl == ctrl)
#define IS_EVENT_KEY2_DUO(evt, key1, key2, ctrl)	(evt && (evt->wVirtKey2 == key1 || evt->wVirtKey2 == key2) && evt->wControl == ctrl)

#define IS_KEY(evt, key)			(evt && evt->wVirtKey1 == key)
#define IS_CONTROL(evt, key)		IS_EVENT_KEY1(evt, key, 0x0004)
#define IS_SHIFT(evt, key)			IS_EVENT_KEY1(evt, key, 0x0001)
#define IS_SHIFT_CONTROL(evt, key)	IS_EVENT_KEY1(evt, key, 0x0005)

#define IS_KEY_DUO(evt, key1, key2)				(evt && (evt->wVirtKey1 == key1 || evt->wVirtKey1 == key2))
#define IS_CONTROL_DUO(evt, key1, key2)			IS_EVENT_KEY1_DUO(evt, key1, key2, 0x0004)
#define IS_SHIFT_DUO(evt, key1, key2)			IS_EVENT_KEY1_DUO(evt, key1, key2, 0x0001)
#define IS_SHIFT_CONTROL_DUO(evt, key1, key2)	IS_EVENT_KEY1_DUO(evt, key1, key2, 0x0005)

#define IS_CONTROL_S1(evt, key)			IS_EVENT_KEY1(evt, key, 0x000C)
#define IS_SHIFT_CONTROL_S1(evt, key)	IS_EVENT_KEY1(evt, key, 0x000F)

#define IS_KEY_ASYNC(key1)				((::GetAsyncKeyState(key1) >> 8) & 0x80)
#define IS_KEY_ASYNC_DUO(key1, key2)	(((::GetAsyncKeyState(key1) >> 8) & 0x80) && ((::GetAsyncKeyState(key2) >> 8) & 0x80))
#define IS_CONTROL_ASYNC(key)			IS_KEY_ASYNC_DUO(VK_CONTROL, key)

//----------------------------------------------------------------------
// Sys.cpp
//----------------------------------------------------------------------
UiTGA* GetUiTGA(int id);
//void DrawIcon(int x1, int y1, int nID, double dx = 1.0, double dy = 1.0, DWORD color = 0xFFFFFFFF);
void DrawIcon(int x1, int y1, int nID, float dx, float dy, DWORD color);
void DrawImage(int x1, int y1, int icx, int icy, float u0, float v0, float u1, float v1, LPSTR szName);
void DrawCross(int x, int y, int dd, DWORD color, BOOL isShadow = FALSE);
void SetUI_Info(cRectangle* uinf, int x, int y, int cx = 0, int cy = 0);
int PrintW(int x, int y, int nFont, DWORD dwColor, wchar_t* wFormat, ...);
BOOL PrintA(int x, int y, int nFont, DWORD dwColor, LPSTR aFormat, ...);
void GetTextDim(int nFont, wchar_t* pText, SIZE* pDim);
void PrintRoundW(int x, int y, int ccx, int ccy, float angle, float f0, int nFont, DWORD dwColor, WCHAR* wFormat, ...);

QuestStru* cInterpretSQW_GetQuestStru(DWORD nQuest);
cWorldView2* WorldView2_GetView();
BOOL IsInRect(int x, int y, int vx, int vy, int vcx, int vcy);

DWORD UI_Manager_GetMainMenuWindowID();
DWORD UI_Manager_GetGameWindowID();
BOOL UI_Manager_IsConsole();


DWORD _get_file_size(FILE* f);
char* GetModulePath();
void OverviewInit(int hx, int hy);


//----------------------------------------------------------------------
// Console.cpp
//----------------------------------------------------------------------
void Console_PrintA(LPSTR aFormat, ...);


extern int g_curx, g_cury;
extern cInt2 g_int2;


//----------------------------------------------------------------------
typedef BOOL (CALLBACK *PFN_ENUMFILESPROC) (LPCSTR, int, WIN32_FIND_DATA*, void*);
class TextResource
{
public:
	int nLangText;
	EString m_ResRoot;
	int m_nResRootLen;

	TextResource();
	~TextResource();

	int EnumFiles(LPCSTR szRootFolder, PFN_ENUMFILESPROC pfnEnumFilesProc, void* lpParam);
};
extern TextResource g_res;
int GetLanguageNo(char* szLangAbbr);
extern wchar_t g_UserName[64];
extern BOOL g_isLoadGame;

//----------------------------------------------------------------------
// SettingsCfg.cpp
//----------------------------------------------------------------------
class SettingsConfig
{
public:

	SettingsConfig();
	~SettingsConfig();

	int GetInteger(char* szParam, int nDef);
	char* GetString(char* szParam, char* szDef);
	cRectangle* GetRectangle(char* szParam);
	cPosition* GetPosition(char* szParam);
	cInt2* GetInt2(char* szParam);

	void SetInteger(char* szParam, int n);
	void SetString(char* szParam, char* szStr);
	void SetInt2(char* szParam, cInt2* i2);



};
extern SettingsConfig g_scfg;

BOOL Cfg_IsParameter(char* buff, char* key);
int Cfg_GetInteger(char* buff, char* key, int def);
DWORD Cfg_GetHex(char* buff, char* key, DWORD def);

void PostVirtualKey(BYTE bVirtualKey);
void PostScanKey(BYTE bVirtualKey, BYTE bScanDown, BYTE bScanUp);

